using System;
using System.Windows.Forms;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

using Direct3D = Microsoft.DirectX.Direct3D;


namespace MyRobot
{

    // {bg̃p[c̒Pʍs\
    class AxisObject
    {
        private int unitSize = 12;  // `p̍W

        private VertexBuffer unitBuffer = null;

        // Unit̃AEgC\F
        private ColorValue m_Color = new ColorValue(1.00f, 1.00f, 1.00f, 1.00f);

        public AxisObject()
        {
            // 
            // TODO: RXgN^ WbNɒǉĂB
            //
        }



        public void CreateVB(Device device)
        {
            // W̍쐬     
            unitBuffer = new VertexBuffer(
                typeof(CustomVertex.PositionColored),
                unitSize,
                device,
                Usage.WriteOnly,
                CustomVertex.PositionColored.Format,
                Pool.Default);


            // \[X̃bN (CPUɂL̈ւ̃ANZX)
            CustomVertex.PositionColored[] verts = (CustomVertex.PositionColored[])unitBuffer.Lock(0, 0);

//          float size = 1.0f;
            float size = 0.01f;

            int i = 0;

            // x
            verts[i].X = -size; verts[i].Y = 0;     verts[i].Z = 0;     verts[i].Color = System.Drawing.Color.Red.ToArgb(); i++;
            verts[i].X =  size; verts[i].Y = 0;     verts[i].Z = 0;     verts[i].Color = System.Drawing.Color.Red.ToArgb(); i++;

            // y
            verts[i].X = 0;     verts[i].Y = -size; verts[i].Z = 0;     verts[i].Color = System.Drawing.Color.Green.ToArgb(); i++;
            verts[i].X = 0;     verts[i].Y =  size; verts[i].Z = 0;     verts[i].Color = System.Drawing.Color.Green.ToArgb(); i++;

            // z
/*
            verts[i].X = 0;     verts[i].Y = 0;     verts[i].Z = -size; verts[i].Color = System.Drawing.Color.Blue.ToArgb(); i++;
            verts[i].X = 0;     verts[i].Y = 0;     verts[i].Z =  size; verts[i].Color = System.Drawing.Color.Blue.ToArgb(); i++;
*/
            verts[i].X = 0; verts[i].Y = 0; verts[i].Z = -size; verts[i].Color = System.Drawing.Color.DarkTurquoise.ToArgb(); i++;
            verts[i].X = 0; verts[i].Y = 0; verts[i].Z =  size; verts[i].Color = System.Drawing.Color.DarkTurquoise.ToArgb(); i++;

            // x AEgC
            verts[i].X = 0;     verts[i].Y = 0;     verts[i].Z = -size; verts[i].Color = this.m_Color.ToArgb(); i++;
            verts[i].X = size;  verts[i].Y = 0;     verts[i].Z = 0;     verts[i].Color = this.m_Color.ToArgb(); i++;

            // -x AEgC
            verts[i].X = 0;     verts[i].Y = 0;     verts[i].Z = -size; verts[i].Color = this.m_Color.ToArgb(); i++;
            verts[i].X = -size; verts[i].Y = 0;     verts[i].Z = 0;     verts[i].Color = this.m_Color.ToArgb(); i++;

            // y  AEgC
            verts[i].X = 0;     verts[i].Y = 0;     verts[i].Z = -size; verts[i].Color = this.m_Color.ToArgb(); i++;
            verts[i].X = 0;     verts[i].Y = size;  verts[i].Z = 0;     verts[i].Color = this.m_Color.ToArgb();

            // \[X̃AbN
            unitBuffer.Unlock();
        }




        // obt@J
        public void Dispose()
        {
            if (null != this.unitBuffer)
            {
                this.unitBuffer.Dispose();
            }
        }





        // ` (_pA`惂[hA_tH[}bgݒɎs)
        // ʏ̕\ʒuw肵ĕ`
        public void Draw\ʒuw(Device device, ModelViewerCamera camera, Vector3 \ʒu, Matrix Pʍs)
        {
            // ]s쐬
            Matrix m = Pʍs;

            // _̉]
            m *= camera.WorldMatrix;
            m *= camera.ViewMatrix;

            // \ʒu̎w
            /*
                    m.M41 = 10.0f;  // x
                    m.M42 = 10.0f;  // y
                    m.M43 = 32.0f;  // z
            */
            m.M41 = \ʒu.X; // x
            m.M42 = \ʒu.Y; // y
            m.M43 = \ʒu.Z; // z

            // [hsݒ
            device.Transform.World = m;

            //-----------------------------------------------------
            // r[sݒ
            device.Transform.View = Matrix.Identity;

            //-----------------------------------------------------
            // W`
            // _obt@foCX̃f[^ Xg[ɃoCh
            device.SetStreamSource(
                0,                                  // 0  -1(Xg[̍ő吔)܂ł͈̔͂̃f[^ Xg[w
                unitBuffer,                         // w肵f[^ Xg[ɃoCh钸_obt@
                0);                                 // Xg[擪璸_f[^擪܂ł̃ItZbg (oCgP)

            device.VertexFormat = CustomVertex.PositionColored.Format;

            // v~eBũV[PX_O
            device.DrawPrimitives(
                PrimitiveType.LineList,                 // _Ov~eBu̎
                0,                                      // [hŏ̒_̃CfbNX
                6);                                     // _Ov~eBu
        }


    }
}
