//-----------------------------------------------------------------------------
// File: MyRobot.cs
//
// Starting point for new Direct3D applications
//
// Copyright (c) Microsoft Corporation. All rights reserved.
//-----------------------------------------------------------------------------

/*
 * tetrapod eg|bh
 *    robot {bg
 * tetrabot eg{bg()
 */


//#define DEBUG_VS   // Uncomment this line to debug vertex shaders 
//#define DEBUG_PS   // Uncomment this line to debug pixel shaders 

using System;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

// j[.vWFNg.QƂ̒ǉsystem.xml.dllǉ
using System.Xml;
using DefineRobot;


namespace MyRobot
{

    //  }EXɂsbNꂽΏێ
    public enum sbN
    {
        l,
        I,
        {fBA,    // {fB㔼
        {fBB,    // {fB
        p[c      // A[p[ĉÂꂩ
    }
    
    
    /// <summary>MyRobot Sample Class</summary>
    public class MyRobot : IFrameworkCallback, IDeviceCreation
    {
        #region Creation
        /// <summary>Create a new instance of the class</summary>
        public MyRobot(Framework f) 
        { 
            // Store framework
            sampleFramework = f; 
            // Create dialogs
            hud = new Dialog(sampleFramework); 
            sampleUi = new Dialog(sampleFramework); 
        }
        #endregion

        // constants
        private static readonly ColorValue YellowColor = new ColorValue(1.0f, 1.0f, 0.0f, 1.0f);


        // Variables
        private Framework sampleFramework = null; // Framework for samples
        private Font statsFont = null; // Font for drawing text
        private Sprite textSprite = null; // Sprite for batching text calls
        private Effect effect = null; // D3DX Effect Interface

        private ModelViewerCamera camera = new ModelViewerCamera(); // A model viewing camera

        private bool isHelpShowing = true; // If true, renders the UI help text

        private Dialog hud = null; // dialog for standard controls
        private Dialog sampleUi = null; // dialog for sample specific controls

        // HUD Ui Control constants
        private const int ToggleFullscreen = 1;
        private const int ToggleReference = 3;
        private const int ChangeDevice = 4;


        // vOݒ̕ۑ
        public config config = new config();

        // XMLAj[VNX
        public XMLAnime XMLAnime = new XMLAnime();


        // ppp
        public robotUnit[]  RobotUnit;

        // --------------------------------
        // f`t@CǍ
        private `Unit `Unit = new `Unit();

        // Aj
        public bool bAj = false;        // trueŃ|[YύXAj̎s
        public robotUnit[] RobotAnimeJn; // Aj[VɊJn|[Yi[ 
        public robotUnit[] RobotAnimeڕW; // Aj[VɈړڕWƂȂ|[Yi[ 

        public int AjJE^ = 0;      // ̃t[Ń|[YςB 

        
        // xmlAj(̃|[YǂݍŃAj[V)
        public bool bXmlAj = false;     // truexmlAj̎s
        public robotUnit[] xmlRobotAnimeJn=null; // Aj[VɊJn|[Yi[ 
        public robotUnit[] xmlRobotAnimeڕW=null; // Aj[VɈړڕWƂȂ|[Yi[ 

        
        public int xmlAjJE^ = 0;  // w̃t[Ń|[YςB 
        public int xml|[YJE^ = 0;  // ω|[Y

        public int[] xmlAjt[;      // |[Ỹt[i[

        public Vector3[] xmlAjΈړW;      // |[Y̑ΈړWi[
        public Vector3[] xmlAjΈړW;      // |[Y̐ΈړWi[

        public Vector3 t[ΈړW = new Vector3();// 1t[̐ΈړWi[

        int CheckBox3;  // UI:Aj`FbN{bNX
        int CheckBox1;  // UI:_̑`FbN{bNX Aj`FbNꂽoffɂB      

        bool bXmlAjCheckBox = false; // UI\/\ ؑ֎ɃAj`FbN{bNX̗L/𕜌B

        // ---
        private AxisObject Axis = new AxisObject(); // p[c̒Pʍs\W

        // }EX J[\ʒu
        private short mouseX = 0;
        private short mouseY = 0;

        private int windowWidth;
        private int windowHeight;

        // ------------------------------------------
        private bool bMouseLeftButtonDown = false;


        // --------------------------------
        // _̑
        private bool b̑ = false;

        private uint    ̑W = 0x0;
        private float   ̑ang = 0.0f;

        // ̑p _ɉ]WI
        [FlagsAttribute]
        enum W : uint
        {
            none = 0x0,// 000
            x = 0x1,// 001
            y = 0x2,// 010
            z = 0x4 // 100
        };
        /*
         *   zyx
         * 1 001
         * 2 010
         * 3 011
         * 4 100
         * 5 101
         * 6 110
         * 7 111
         */


        // --------------------------------
        // @̎pYW]p
        private bool b̎ = false;   // ̗̎L

        private float angY = 9.5f;  // x
        private float radY = 0.0f;  // WA

        private float fԊu = 1.6f;
        private float J = 16.0f;


        // --------------------------------
        private bool bUI\ = true;	// UI(_CAO)\

        // --------------------------------
        // fps
        private float m_f`掞 = 0.0f;

        // -----
        // GUI{^ɂOnFrameMove\bhŎs@\
        private ApplicationState applicationState = ApplicationState.RenderScene; // State of the application

        private enum ApplicationState
        {
            |[Y,
            |[Yۑ,
            |[YǍ,
            fǍ,
            eNX`ؑ,
            XMLAj,
            wiFݒ,
            RenderScene
        };



        // -------------------------------------------------
        // sbNɂIꂽ]Ώێ
        private sbN ]Ώ     = sbN.I;
        private sbN O]Ώ = sbN.l;

/*
//      private enum sbN
        private enum pi
        {
            l,
            I,
            {fBA,    // {fB㔼
            {fBB,    // {fB
            p[c      // A[p[ĉÂꂩ
        };
 */
 
        // sbNΏ
        private int iPickArm = -1;
        private int iPickPart = -1;





        // t@C I[v/Z[u _CAO NfBNg
        string m_|[YfBNg = System.Windows.Forms.Application.StartupPath + @"\..\..\xml";
        string m_AjfBNg = System.Windows.Forms.Application.StartupPath + @"\..\..\anime";
        string m_ffBNg = System.Windows.Forms.Application.StartupPath + @"\..\..\model";

        string m_t@C = "";

        // wiFݒ
        private int iwiF = 0x004a3f8f;


        // Light stuff (Widget EBWbg) DirectionWidget:u
        DirectionWidget CgRg[ = new DirectionWidget();	// (\p)
        DirectionWidget p[cRg[ = new DirectionWidget();	// (\p)


        // }EXɂ葀삳p[c̒Pʍs
        Matrix }EXp[cs = Matrix.Identity;
        Matrix }EXPʍs   = Matrix.Identity;


        /// <summary>
        /// Called during device initialization, this code checks the device for some 
        /// minimum set of capabilities, and rejects those that don't pass by returning false.
        /// </summary>
        public bool IsDeviceAcceptable(Caps caps, Format adapterFormat, Format backBufferFormat, bool windowed)
        {
            // Skip back buffer formats that don't support alpha blending
            if (!Manager.CheckDeviceFormat(caps.AdapterOrdinal, caps.DeviceType, adapterFormat, 
                Usage.QueryPostPixelShaderBlending, ResourceType.Textures, backBufferFormat))
                return false;

            return true;
        }

        /// <summary>
        /// This callback function is called immediately before a device is created to allow the 
        /// application to modify the device settings. The supplied settings parameter 
        /// contains the settings that the framework has selected for the new device, and the 
        /// application can make any desired changes directly to this structure.  Note however that 
        /// the sample framework will not correct invalid device settings so care must be taken 
        /// to return valid device settings, otherwise creating the Device will fail.  
        /// </summary>
        public void ModifyDeviceSettings(DeviceSettings settings, Caps caps)
        {
            // If device doesn't support HW T&L or doesn't support 1.1 vertex shaders in HW 
            // then switch to SWVP.
            if ( (!caps.DeviceCaps.SupportsHardwareTransformAndLight) ||
                (caps.VertexShaderVersion < new Version(1,1)) )
            {
                settings.BehaviorFlags = CreateFlags.SoftwareVertexProcessing;
            }
            else
            {
                settings.BehaviorFlags = CreateFlags.HardwareVertexProcessing;
            }

            // This application is designed to work on a pure device by not using 
            // any get methods, so create a pure device if supported and using HWVP.
            if ( (caps.DeviceCaps.SupportsPureDevice) && 
                ((settings.BehaviorFlags & CreateFlags.HardwareVertexProcessing) != 0 ) )
                settings.BehaviorFlags |= CreateFlags.PureDevice;

            // Debugging vertex shaders requires either REF or software vertex processing 
            // and debugging pixel shaders requires REF.  
#if(DEBUG_VS)
            if (settings.DeviceType != DeviceType.Reference )
            {
                settings.BehaviorFlags &= ~CreateFlags.HardwareVertexProcessing;
                settings.BehaviorFlags |= CreateFlags.SoftwareVertexProcessing;
            }
#endif
#if(DEBUG_PS)
            settings.DeviceType = DeviceType.Reference;
#endif
            // For the first device created if its a REF device, optionally display a warning dialog box
            if (settings.DeviceType == DeviceType.Reference)
            {
                Utility.DisplaySwitchingToRefWarning(sampleFramework, "MyRobot");
            }

        }









        /// <summary>
        /// This function loads the mesh and ensures the mesh has normals; it also optimizes the 
        /// mesh for the graphics card's vertex cache, which improves performance by organizing 
        /// the internal triangle list for less cache misses.
        /// </summary>
        private Mesh LoadMesh(Device device, string filename)
        {
            // Load the mesh with D3DX and get back a Mesh.  For this
            // sample we'll ignore the X file's embedded materials since we know 
            // exactly the model we're loading.  See the mesh samples such as
            // "OptimizedMesh" for a more generic mesh loading example.
            string path = Utility.FindMediaFile(filename);
            Mesh m = Mesh.FromFile(path, MeshFlags.Managed, device);

            // Make sure there are normals which are required for lighting
            if ((m.VertexFormat & VertexFormats.Normal) == 0)
            {
                // Clone the mesh
                Mesh tempMesh = null;
                using (m)
                {
                    tempMesh = m.Clone(m.Options.Value, m.VertexFormat | VertexFormats.Normal,
                        device);
                    // Compute the normals
                    tempMesh.ComputeNormals();
                }
                m = tempMesh;
            }

            // Optimize the mesh for this graphics card's vertex cache 
            // so when rendering the mesh's triangle list the vertices will 
            // cache hit more often so it won't have to re-execute the vertex shader 
            // on those vertices so it will improve perf.     
            int[] adj = new int[m.NumberFaces * 3];
            m.GenerateAdjacency(1e-6f, adj);
            m.OptimizeInPlace(MeshFlags.OptimizeVertexCache, adj);

            // return the mesh
            return m;
        }











        /// <summary>
        /// This event will be fired immediately after the Direct3D device has been 
        /// created, which will happen during application initialization and windowed/full screen 
        /// toggles. This is the best location to create Pool.Managed resources since these 
        /// resources need to be reloaded whenever the device is destroyed. Resources created  
        /// here should be released in the Disposing event. 
        /// </summary>
        private void OnCreateDevice(object sender, DeviceEventArgs e)
        {
            // Initialize the stats font
            statsFont = ResourceCache.GetGlobalInstance().CreateFont(e.Device, 15, 0, FontWeight.Bold, 1, false, CharacterSet.Default,
                Precision.Default, FontQuality.Default, PitchAndFamily.FamilyDoNotCare | PitchAndFamily.DefaultPitch
                , "Arial");


            // Define DEBUG_VS and/or DEBUG_PS to debug vertex and/or pixel shaders with the 
            // shader debugger. Debugging vertex shaders requires either REF or software vertex 
            // processing, and debugging pixel shaders requires REF.  The 
            // ShaderFlags.Force*SoftwareNoOptimizations flag improves the debug experience in the 
            // shader debugger.  It enables source level debugging, prevents instruction 
            // reordering, prevents dead code elimination, and forces the compiler to compile 
            // against the next higher available software target, which ensures that the 
            // unoptimized shaders do not exceed the shader model limitations.  Setting these 
            // flags will cause slower rendering since the shaders will be unoptimized and 
            // forced into software.  See the DirectX documentation for more information about 
            // using the shader debugger.
            ShaderFlags shaderFlags = ShaderFlags.NotCloneable;
#if(DEBUG_VS)
            shaderFlags |= ShaderFlags.ForceVertexShaderSoftwareNoOptimizations;
#endif
#if(DEBUG_PS)
            shaderFlags |= ShaderFlags.ForcePixelShaderSoftwareNoOptimizations;
#endif
            // Read the D3DX effect file
            string path = Utility.FindMediaFile("MyRobot.fx");
            effect = ResourceCache.GetGlobalInstance().CreateEffectFromFile(e.Device,
                path, null, null, shaderFlags, null);

            // Setup the camera's view parameters
            camera.SetViewParameters(new Vector3(0.0f, 1.0f, -5.0f), Vector3.Empty);
            camera.SetRadius(8.0f, 1.0f, 256.0f);   // J̋ default,min,max


            // Setup direction widget
            DirectionWidget.OnCreateDevice(e.Device);
            CgRg[.Radius = 3.0f;	// aݒ
            p[cRg[.Radius = 1.0f;	// aݒ

        }
        
        /// <summary>
        /// This event will be fired immediately after the Direct3D device has been 
        /// reset, which will happen after a lost device scenario. This is the best location to 
        /// create Pool.Default resources since these resources need to be reloaded whenever 
        /// the device is lost. Resources created here should be released in the OnLostDevice 
        /// event. 
        /// </summary>
        private void OnResetDevice(object sender, DeviceEventArgs e)
        {
            SurfaceDescription desc = e.BackBufferDescription;
            // Create a sprite to help batch calls when drawing many lines of text
            textSprite = new Sprite(e.Device);

            // Setup the camera's projection parameters
            float aspectRatio = (float)desc.Width / (float)desc.Height;
            camera.SetProjectionParameters( (float)Math.PI / 4, aspectRatio, 0.1f, 1000.0f );

            camera.SetWindow(desc.Width, desc.Height);

            /*
                        camera.SetButtonMasks(
                            (int)MouseButtonMask.Left,    // rotateModel( Left)WorldMatrix
                            (int)MouseButtonMask.Wheel,   // zoom(Wheel)
                            (int)MouseButtonMask.Right ); // rotateCamera(E Right)ViewMatrix
            */
            camera.SetButtonMasks(
                (int)MouseButtonMask.None,      // rotateModel( Left)WorldMatrix f]
                (int)MouseButtonMask.Wheel,     // zoom(Wheel)
                (int)MouseButtonMask.Right);    // rotateCamera(E Right)ViewMatrixJ]

            windowWidth  = desc.Width;
            windowHeight = desc.Height;

            // ppp
            // Set device transforms
            e.Device.Transform.Projection = camera.ProjectionMatrix;

            // Cgݒ
            // .xt@C烍[hꂽbV̕\Ɏgp
            // [0]:Cgԍ0ɐݒ
            // Ft̕sݒ
            e.Device.Lights[0].Type = LightType.Directional;
            e.Device.Lights[0].Diffuse = System.Drawing.Color.White;

            e.Device.Lights[0].Direction = new Vector3(
                -CgRg[.LightDirection.X,
                -CgRg[.LightDirection.Y,
                -CgRg[.LightDirection.Z);

            e.Device.Lights[0].Enabled = true; // Cg I


            // JOItɂāA[U[ɎOp`̑OʂƔwʂ悤ɂ܂B
            e.Device.RenderState.CullMode = Cull.None;
            e.Device.RenderState.Lighting = true;
            e.Device.RenderState.FillMode = FillMode.Solid;


            // Z obt@Iɂ܂B
            e.Device.RenderState.ZBufferEnable = true;

            // ArGg I
            // ArGǵAgUAׂẴIuWFNglɏƂ炷CgB
//          e.Device.RenderState.Ambient = System.Drawing.Color.FromArgb(0x808080);
//          e.Device.RenderState.Ambient = System.Drawing.Color.White;
            e.Device.RenderState.Ambient = System.Drawing.Color.FromArgb(0xa0a0a0);


            // ppp
            this.RobotUnit[0].CreateVB(e.Device, this.`Unit );
//            this.RobotAnimeJn[0].CreateVB(e.Device, this.`Unit );
//            this.RobotAnimeڕW[0].CreateVB(e.Device, this.`Unit );

            this.Axis.CreateVB(e.Device);


/*
            if (this.xmlRobotAnimeJn != null)
            {
                for (int i = 0; i < this.xmlRobotAnimeJn.Length; i++)
                {
                    this.xmlRobotAnimeJn[i].CreateVB(e.Device, this.`Unit);
                }
            }
*/

            // zzz xmlAjł͒Pʍŝ݂QƂ̂CreateVB/Dispose͍sȂ
            /*
            if (this.xmlRobotAnimeڕW != null)
            {
                for (int i = 0; i < this.xmlRobotAnimeڕW.Length; i++)
                {
                    this.xmlRobotAnimeڕW[i].CreateVB(e.Device);
                }
            }
            */

            // Setup UI locations
            hud.SetLocation(desc.Width-170, 0);
            hud.SetSize(170,170);

//          sampleUi.SetLocation(desc.Width - 170, desc.Height - 350);
            sampleUi.SetLocation(desc.Width - 170, desc.Height - 370);
            sampleUi.SetSize(170, 300);

            // Reset items
            CgRg[.OnResetDevice(desc);
            p[cRg[.OnResetDevice(desc);

            // }EX̂ǂ̃{^ŃCg]邩w
            CgRg[.RotateButtonMask = MouseButtonMask.Middle;

            // }EX̂ǂ̃{^Ńp[c]邩w
            p[cRg[.RotateButtonMask = MouseButtonMask.Middle;
        }



        /// <summary>
        /// This event function will be called fired after the Direct3D device has 
        /// entered a lost state and before Device.Reset() is called. Resources created
        /// in the OnResetDevice callback should be released here, which generally includes all 
        /// Pool.Default resources. See the "Lost Devices" section of the documentation for 
        /// information about lost devices.
        /// </summary>
        private void OnLostDevice(object sender, EventArgs e)
        {
            if (textSprite != null)
            {
                textSprite.Dispose();
                textSprite = null;
            }
            
            // ppp
            this.RobotUnit[0].Dispose();

/*
            if (this.xmlRobotAnimeJn != null)
            {
                for (int i = 0; i < this.xmlRobotAnimeJn.Length; i++)
                {
                    this.xmlRobotAnimeJn[i].Dispose();
                }
            }
*/
/*
            if (this.xmlRobotAnimeڕW != null)
            {
                for (int i = 0; i < this.xmlRobotAnimeڕW.Length; i++)
                {
                    this.xmlRobotAnimeڕW[i].Dispose();
                }
            }
*/
            this.Axis.Dispose();

            // Update the direction widget CgRg[
            DirectionWidget.OnLostDevice();
        }

        /// <summary>
        /// This callback function will be called immediately after the Direct3D device has 
        /// been destroyed, which generally happens as a result of application termination or 
        /// windowed/full screen toggles. Resources created in the OnCreateDevice callback 
        /// should be released here, which generally includes all Pool.Managed resources. 
        /// </summary>
        private void OnDestroyDevice(object sender, EventArgs e)
        {
            // -------------------------------------------
            // Q[ݒ̕ۑ"MyRobot.config"
            try
            {
                /*
                http://dobon.net/vb/dotnet/file/xmlserializer.html
                XMLt@Cɏ܂vf́ApubNołtB[hƃvpeBłB

                ɁAǂݍ݁A邢͏݂ĂȂvpeB́A
                pubNołĂ܂܂B

                ܂AVAIuWFNg̃NXɂ́A
                K̃RXgN^iȂRXgN^jKvłB
                */
                // ----------------------------
                // configNXɃvOeݒ
                // @̎l
                config.angY = this.angY;  // x
                config.radY = this.radY;  // WA

                config.fԊu = this.fԊu;
                config.J = this.J;

                config.iwiF = this.iwiF;

                // \f
                config.RobotUnit = this.RobotUnit[0];


                //ۑ̃t@C (exẽtpX擾ÃfBNg𓾂)
                string fileName = System.IO.Path.GetDirectoryName(System.Windows.Forms.Application.ExecutablePath)
                                    + "\\" + "MyRobot.config";

                //XMLt@Cɏށ
                //XmlSerializerIuWFNg쐬
                //ރIuWFNǧ^w肷
                System.Xml.Serialization.XmlSerializer serializer1 =
                    //                  new System.Xml.Serialization.XmlSerializer( typeof(robotUnit) );
                    new System.Xml.Serialization.XmlSerializer(typeof(config));

                //t@CJ
                System.IO.FileStream fs1 =
                    new System.IO.FileStream(fileName, System.IO.FileMode.Create);

                //VAAXMLt@Cɕۑ
                //              serializer1.Serialize( fs1, RobotUnit[0] );
                serializer1.Serialize(fs1, config);

                //
                fs1.Close();
            }
            catch
            {
                // OA܂Ȃ
            }
            // -------------------------------------------

            // Update the direction widget CgRg[
            DirectionWidget.OnDestroyDevice();

        }




        /// <summary>
        /// This callback function will be called once at the beginning of every frame. This is the
        /// best location for your application to handle updates to the scene, but is not 
        /// intended to contain actual rendering calls, which should instead be placed in the 
        /// OnFrameRender callback.  
        /// </summary>
        public void OnFrameMove(Device device, double appTime, float elapsedTime)
        {
            // Update the camera's position based on user input 
            camera.FrameMove(elapsedTime);

            // ppp
            // [hs r[sݒ
            // (HLSLgpȂ\̏ꍇɕKv)
            device.Transform.World = camera.WorldMatrix;
            device.Transform.View = camera.ViewMatrix;



            // }EX ENbNo
            if (camera.IsMouseLeftButtonDown)
            {
                if (!bMouseLeftButtonDown)
                {
                    // ̎łȂ΃sbNo
                    if (!b̎)
                    {
                        this.sbNo();  // ]̑ΏۂƂȂ郁bVsbNo

                        if ( sbN.p[c == this.]Ώ)
                        {
// ccc OnFrameMove sbNo
                            p[cRg[.arc.CurrentQuaternion    = Quaternion.Identity;
                            p[cRg[.rotation                 = Matrix.Identity;
                            p[cRg[.rotationSnapshot         = Matrix.Identity;

                            // *****************
                            this.}EXp[cs = this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].parts;
                            Vector3 v3 = new Vector3(-}EXp[cs.M31, -}EXp[cs.M32, -}EXp[cs.M33);
                            v3.Normalize();
                            p[cRg[.LightDirection = v3; // p[c̐ݒ 
                            // *****************

                            p[cRg[.Radius = this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].axis.Length() * 2.4f;
                        }
                    }
                }
                bMouseLeftButtonDown = true;
            }
            else
            {
                bMouseLeftButtonDown = false;
            }

// ccc OnFrameMove

            if ( sbN.p[c == this.]Ώ)
            {
                // p[c{fBtǂ
                Matrix }EXep[cs = Matrix.Identity;
                if (0 == this.iPickPart)    // 0:A[̃{fBtp[c
                {
                    // {fBA():tA[:0,1
                    // {fBB():tA[:2,3
                    if (0 == this.iPickArm || 1 == this.iPickArm)
                    {
                        // {fB A tA[
                        }EXep[cs = this.RobotUnit[0].Body.BodysA;
                    }
                    else
                    {
                        // {fB B tA[
                        }EXep[cs = this.RobotUnit[0].Body.BodysBA;
                    }
                }
                else
                {
                    }EXep[cs = this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].efparts;
                }

                }EXPʍs = (this.}EXp[cs * p[cRg[.exM) * Matrix.Invert(}EXep[cs);
                }EXPʍs.M41 = }EXPʍs.M42 = }EXPʍs.M43 = 0;

                this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].Pʍs = }EXPʍs;
            }


            // ---------------------------------------------------
            // \p[cSē
            if (b̑)
            {
                for (int arm = 0; arm < 4; arm++)
                {
                    for (int part = 0; part < 13; part++)
                    {
                        if ((̑W & (uint)W.x) == (uint)W.x)
                        {
                            this.RobotUnit[0].Arm[arm].Parts[part].RotateX_Pitch(̑ang);
                        }
                        if ((̑W & (uint)W.y) == (uint)W.y)
                        {
                            this.RobotUnit[0].Arm[arm].Parts[part].RotateY_Yaw(̑ang);
                        }
                        if ((̑W & (uint)W.z) == (uint)W.z)
                        {
                            this.RobotUnit[0].Arm[arm].Parts[part].RotateZ_Roll(̑ang);
                        }
                    }
                }
            }


            // ----------------------------------------------------
            // |[Y Aj[V
            // 2̃|[YԂ̃Aj[V
            if (this.bAj)
            {
                int animeframe = 30;

                float t = AjJE^ * (1.0f / (float)animeframe);    // ԋ

                this.RobotUnit[0].Anime(this.RobotAnimeJn[0], this.RobotAnimeڕW[0], t);

                this.AjJE^++;

                if (animeframe < AjJE^)
                {
                    // |[YύXAj̏I
                    this.RobotUnit[0].Anime(this.RobotAnimeJn[0], this.RobotAnimeڕW[0], 1);
                    this.bAj = false;
                    this.AjJE^ = 0;

                    // ڕWւAAjĎsŌ̃|[Yɖ߂
//                    this.RobotAnimeڕW[0].Dispose();
                    this.RobotAnimeڕW[0] = null;
                    this.RobotAnimeڕW[0] = new robotUnit();
                    this.RobotAnimeڕW[0] = (robotUnit)this.RobotAnimeJn[0].Clone();
                }
            }



            // ----------------------------------------------------
            // xmlt@Cɒ`ꂽ|[ỸAj[V
            if (this.bXmlAj)
            {
                int animeframe = this.xmlAjt[[this.xml|[YJE^];
                float t = xmlAjJE^ * (1.0f / (float)animeframe);    // ԋ

                // 1AnimePartm[h ̊Jn
                if (0 == this.xmlAjJE^)
                {
                    // AnimePartm[hɐΈړW(ax,ay,az)܂܂鎞At[̈ړ߂B
                    if (float.MinValue != this.xmlAjΈړW[this.xml|[YJE^].X)
                    {
                        t[ΈړW = (this.xmlAjΈړW[this.xml|[YJE^] - this.RobotUnit[0].Body.pos);

                        t[ΈړW.X = t[ΈړW.X / animeframe;
                        t[ΈړW.Y = t[ΈړW.Y / animeframe;
                        t[ΈړW.Z = t[ΈړW.Z / animeframe;
                    }
                }


                // posړAj

                // xmlAjΈړW̐ݒ肪A
                // this.xmlAjΈړW̐ݒ肪ꍇ́AړB
                if (0 != this.xmlAjΈړW[this.xml|[YJE^].Length())
                {
                    this.RobotUnit[0].Body.posΈړ(this.xmlAjΈړW[this.xml|[YJE^]);
                }
                else if (float.MinValue != this.xmlAjΈړW[this.xml|[YJE^].X)
                {
                    this.RobotUnit[0].Body.posΈړ(t[ΈړW);
                }


                this.RobotUnit[0].Anime(this.xmlRobotAnimeJn[0], this.xmlRobotAnimeڕW[this.xml|[YJE^], t);

                this.xmlAjJE^++;

                // |[YύXI?
                if (animeframe < xmlAjJE^)
                {
                    // 1̃|[YύX̏IÃ|[Y
                    if (float.MinValue != this.xmlAjΈړW[this.xml|[YJE^].X)
                        this.RobotUnit[0].Body.pos = this.xmlAjΈړW[this.xml|[YJE^];

                    this.RobotUnit[0].Anime(this.xmlRobotAnimeJn[0], this.xmlRobotAnimeڕW[this.xml|[YJE^], 1);

                    // Aj[V̊Jn|[Y̍XV
//                    this.xmlRobotAnimeJn[0].Dispose();
                    this.xmlRobotAnimeJn[0] = null;
                    this.xmlRobotAnimeJn[0] = new robotUnit();
                    this.xmlRobotAnimeJn[0] = (robotUnit)this.xmlRobotAnimeڕW[this.xml|[YJE^].Clone();  // N[쐬

                    this.xmlAjJE^ = 0;
                    this.xml|[YJE^++;


                    // xmlAjI?
                    if (this.xmlRobotAnimeڕW.Length <= this.xml|[YJE^)
                    {
                        // ړڕWŏ̎w|[YɂB
                        this.xml|[YJE^ = 0;
                    }

                }
            }




            // -------------------------------------------------------------------------
            // applicationStateɂ鏈I
            switch (applicationState)
            {
                case ApplicationState.eNX`ؑ:
                    {
                        applicationState = ApplicationState.RenderScene;
                        this.RobotUnit[0].Body.eNX`p^[ؑ(device);
                    }
                    break;

                // ----------------------------------------------------
                case ApplicationState.|[Y:
                    {
                        System.Windows.Forms.DialogResult Result;
                        applicationState = ApplicationState.RenderScene;

                        // tXN[?
                        bool bWindowed = sampleFramework.IsWindowed;

                        // tXN[łꍇAꎞB
                        if (!bWindowed) sampleFramework.ToggleFullscreen();

                        Result = System.Windows.Forms.MessageBox.Show(
                                                                "|[Y ?", "MyRobot",
                                                                System.Windows.Forms.MessageBoxButtons.OKCancel,
                                                                System.Windows.Forms.MessageBoxIcon.Question);

                        if (System.Windows.Forms.DialogResult.OK == Result)
                        {
                            // Aj[Vɂ|[Y
                            {
                                // |[YύXAj̊Jn
                                this.bAj = true;
                                this.AjJE^ = 0;

                                // Aj[V̊Jn|[Y̕ۑ
//                                this.RobotAnimeJn[0].Dispose();
                                this.RobotAnimeJn[0] = null;
                                this.RobotAnimeJn[0] = new robotUnit();
//                                this.RobotAnimeJn[0].CreateVB(device, this.`Unit);
                                this.RobotAnimeJn[0] = (robotUnit)RobotUnit[0].Clone();  // N[쐬

                                // Aj[V̖ڕW|[Y̐ݒ
//                                this.RobotAnimeڕW[0].Dispose();
                                this.RobotAnimeڕW[0] = null;
                                this.RobotAnimeڕW[0] = new robotUnit();
//                                this.RobotAnimeڕW[0].CreateVB(device, this.`Unit);
                            }
                        }
                        // tXN[łꍇAꎞB-> ĂуtXN[ 
                        if (!bWindowed) sampleFramework.ToggleFullscreen();

                        // --------
                        XMLAj();	// Aj off/Jnʒu

                    }
                    break;


                case ApplicationState.|[Yۑ:
                    {
                        applicationState = ApplicationState.RenderScene;

                        // tXN[?
                        bool bWindowed = sampleFramework.IsWindowed;

                        // tXN[łꍇAꎞB
                        if (!bWindowed) sampleFramework.ToggleFullscreen();

                        System.Windows.Forms.SaveFileDialog dialog = new System.Windows.Forms.SaveFileDialog();

                        // tB^[XMLݒ
                        dialog.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*";
                        dialog.Title = " |[Yۑ";
                        //                      dialog.InitialDirectory = System.Windows.Forms.Application.StartupPath + @"\..\..\xml";
                        dialog.InitialDirectory = m_|[YfBNg;

                        dialog.FileName = m_t@C;



                        // _CAO\
                        if (System.Windows.Forms.DialogResult.OK == dialog.ShowDialog())
                        {
                            // ok ̏ꍇ XML t@C Z[u
                            // -------------------------------------------
                            // |[Y̕ۑ
                            try
                            {
                                /*
                                http://dobon.net/vb/dotnet/file/xmlserializer.html
                                XMLt@Cɏ܂vf́ApubNołtB[hƃvpeBłB

                                ɁAǂݍ݁A邢͏݂ĂȂvpeB́A
                                pubNołĂ܂܂B

                                ܂AVAIuWFNg̃NXɂ́A
                                K̃RXgN^iȂRXgN^jKvłB
                                */

                                //ۑ̃t@C
                                string fileName = dialog.FileName;

                                // t@C I[v/Z[u _CAO NfBNg XV
                                m_|[YfBNg = System.IO.Path.GetDirectoryName(fileName);

                                //XMLt@Cɏށ
                                //XmlSerializerIuWFNg쐬
                                //ރIuWFNǧ^w肷
                                System.Xml.Serialization.XmlSerializer serializer1 =
                                    new System.Xml.Serialization.XmlSerializer(typeof(robotUnit));

                                //t@CJ
                                System.IO.FileStream fs1 =
                                    new System.IO.FileStream(fileName, System.IO.FileMode.Create);

                                //VAAXMLt@Cɕۑ
                                serializer1.Serialize(fs1, RobotUnit[0]);

                                //
                                fs1.Close();
                            }
                            catch
                            {
                                // O:bZ[W{bNX\
                                System.Windows.Forms.MessageBox.Show(
                                        "G[:ۑł܂łB", "MyRobot",
                                        System.Windows.Forms.MessageBoxButtons.OK,
                                        System.Windows.Forms.MessageBoxIcon.Error);

                            }
                            // -------------------------------------------
                        }
                        // tXN[łꍇAꎞB-> ĂуtXN[ 
                        if (!bWindowed) sampleFramework.ToggleFullscreen();
                    }
                    break;


                case ApplicationState.|[YǍ:
                    {
                        applicationState = ApplicationState.RenderScene;

                        // tXN[?
                        bool bWindowed = sampleFramework.IsWindowed;

                        // tXN[łꍇAꎞB
                        if (!bWindowed) sampleFramework.ToggleFullscreen();

                        // I[vt@C_CAO
                        System.Windows.Forms.OpenFileDialog dialog = new System.Windows.Forms.OpenFileDialog();

                        // tB^[XMLݒ
                        dialog.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*";
                        dialog.Title = " |[YǍ";
                        //                      dialog.InitialDirectory = System.Windows.Forms.Application.StartupPath + @"\..\..\xml";
                        dialog.InitialDirectory = m_|[YfBNg;

                        // _CAO\
                        if (System.Windows.Forms.DialogResult.OK == dialog.ShowDialog())
                        {
                            // ok ̏ꍇ XML t@C [h
                            // -----------------------------------------------

                            try
                            {
                                //ۑ̃t@C
                                string fileName = dialog.FileName;

                                // t@C I[v/Z[u _CAO NfBNg XV
                                m_|[YfBNg = System.IO.Path.GetDirectoryName(fileName);

                                m_t@C = dialog.FileName;

                                //XMLt@Cǂݍށ
                                //XmlSerializerIuWFNg̍쐬
                                System.Xml.Serialization.XmlSerializer serializer2 =
                                    new System.Xml.Serialization.XmlSerializer(typeof(robotUnit));

                                //t@CJ
                                System.IO.FileStream fs2 = new System.IO.FileStream(fileName, System.IO.FileMode.Open);

                                // t@Cǂݍ񂾃|[YփAj[Vňړ
                                // |[YύXAj̊Jn
                                this.bAj = true;
                                this.AjJE^ = 0;

                                // Aj[V̊Jn|[Y̕ۑ
//                                this.RobotAnimeJn[0].Dispose();
                                this.RobotAnimeJn[0] = null;
                                this.RobotAnimeJn[0] = new robotUnit();
                                this.RobotAnimeJn[0] = (robotUnit)RobotUnit[0].Clone();  // N[쐬

                                // Aj[V̖ڕW|[Y̐ݒ
//                                this.RobotAnimeڕW[0].Dispose();
                                this.RobotAnimeڕW[0] = null;
                                this.RobotAnimeڕW[0] = new robotUnit();
                                this.RobotAnimeڕW[0] = (robotUnit)serializer2.Deserialize(fs2);
                                // --------------------------------------------

                                // eNX`̐ݒ
                                this.RobotUnit[0].Body.m_eNX`p^[ = RobotAnimeڕW[0].Body.m_eNX`p^[;
                                this.RobotUnit[0].Body.switcheNX`p^[(device);

                                // {fB:[hWʒu
                                this.RobotUnit[0].Body.pos = new Vector3(0, 0, 0);

                                // er̊ep[c̐ep[cĐݒ肷
                                for (int i = 0; i < this.RobotAnimeڕW[0].Arm.Length; i++)
                                {
                                    RobotAnimeڕW[0].Arm[i].efݒ();
                                }
                                // CreateVB Ďs(tVAɂݒ肳ȂڂĐݒ)
//                                this.RobotAnimeڕW[0].CreateVB(device, this.`Unit);

                                //
                                fs2.Close();
                            }
                            catch
                            {
                                // O:bZ[W{bNX\
                                System.Windows.Forms.MessageBox.Show(
                                        "G[:Ǎł܂łB", "MyRobot",
                                        System.Windows.Forms.MessageBoxButtons.OK,
                                        System.Windows.Forms.MessageBoxIcon.Error);
                            }
                            // -----------------------------------------------
                        }

                        // tXN[łꍇAꎞB-> ĂуtXN[ 
                        if (!bWindowed) sampleFramework.ToggleFullscreen();

                        // --------
                        XMLAj();	// Aj off/Jnʒu

                    }
                    break;

                case ApplicationState.XMLAj:
                    {
                        applicationState = ApplicationState.RenderScene;
                        //                      this.XMLAjǍ( device );    // Aj[V`XMLt@CǍ
                        //                      this.xmlAjeXg(device);
                        //                      this.xmlAjeXg2(device);
                        this.XMLAjǍ(device);    // Aj[V`XMLt@CǍ
                    }
                    break;

                case ApplicationState.fǍ:
                    {
                        applicationState = ApplicationState.RenderScene;
                        this.XMLfǍ_CAO(device);
                    }
                    break;


                case ApplicationState.wiFݒ:
                    {
                        applicationState = ApplicationState.RenderScene;

                        // tXN[?
                        bool bWindowed = sampleFramework.IsWindowed;

                        // tXN[łꍇAꎞB
                        if (!bWindowed) sampleFramework.ToggleFullscreen();

                        System.Windows.Forms.ColorDialog dialog = new System.Windows.Forms.ColorDialog();

                        // JX^J[Zbgݒ
                        // RGB = 0x00BBGGRR -> ARGB = 0xAARRGGBB 
                        dialog.CustomColors = new int[] { System.Drawing.ColorTranslator.ToWin32(System.Drawing.Color.FromArgb(0x004a3f8f)) };

                        // F̐ݒ_CAO\
                        if (System.Windows.Forms.DialogResult.OK == dialog.ShowDialog())
                        {
                            // wiFۑ:.configɕۑ/Ǎ
                            this.iwiF = dialog.Color.ToArgb();
                        }

                        // tXN[łꍇAꎞB-> ĂуtXN[ 
                        if (!bWindowed) sampleFramework.ToggleFullscreen();
                    }
                    break;
                // ---------------------------



            }


            // -------------------------------------------------------------------------
            // fps 60fps
            // memo:tXN[fpsRefresh RateɈˑB
            float f = (float)FrameworkTimer.GetTime();
            if (f < m_f`掞)
            {
                System.Threading.Thread.Sleep((int)((m_f`掞 - f) * 1000)); // ~bP
            }
            m_f`掞 = (float)FrameworkTimer.GetTime() + 0.0167f;  // 16.7ms  1/60sec    // bP

        }





        /// <summary>
        /// This callback function will be called at the end of every frame to perform all the 
        /// rendering calls for the scene, and it will also be called if the window needs to be 
        /// repainted. After this function has returned, the sample framework will call 
        /// Device.Present to display the contents of the next buffer in the swap chain
        /// </summary>
        public void OnFrameRender(Device device, double appTime, float elapsedTime)
        {
            bool beginSceneCalled = false;

            // Clear the render target and the zbuffer 
//          device.Clear(ClearFlags.ZBuffer | ClearFlags.Target, 0x002D32AA, 1.0f, 0);
//                                                                                   rrggbb
//          device.Clear( ClearFlags.ZBuffer | ClearFlags.Target, unchecked((int)0x00a0a0a0), 1.0f, 0 );
//          device.Clear( ClearFlags.ZBuffer | ClearFlags.Target, unchecked((int)0x004a3f8f), 1.0f, 0 );

            device.Clear( ClearFlags.ZBuffer | ClearFlags.Target, unchecked( iwiF ), 1.0f, 0 );

            try
            {
                device.BeginScene();
                beginSceneCalled = true;


                // }EX ~h(zC[)o  ]ΏۂIł邱ƁB
                if (camera.IsMouseMiddleButtonDown && sbN.I == this.]Ώ )
                {
                    // Cg\\
                    CgRg[.OnRender(YellowColor, camera.ViewMatrix, camera.ProjectionMatrix, camera.EyeLocation);

                    device.Lights[0].Direction = new Vector3(
                        -CgRg[.LightDirection.X,
                        -CgRg[.LightDirection.Y,
                        -CgRg[.LightDirection.Z);

                    device.Lights[0].Enabled = true; // Cg I Cg̕ύX𔽉fB 
                }

                // p[cI𒆂Ȃ\
                if ( sbN.p[c == this.]Ώ)
                {
                    // Iꂽp[c\\
                    p[cRg[.OnRender(YellowColor, camera.ViewMatrix, camera.ProjectionMatrix, camera.EyeLocation);
                }


                // Update the effect's variables.  Instead of using strings, it would 
                // be more efficient to cache a handle to the parameter by calling 
                // Effect.GetParameter
                effect.SetValue("worldViewProjection", camera.WorldMatrix * camera.ViewMatrix * camera.ProjectionMatrix);
                effect.SetValue("worldMatrix", camera.WorldMatrix);
                effect.SetValue("appTime", (float)appTime);

                ////////////////////////////////////////////////
                // \ʒuw肵ĕ\(ʂ̋ɉ]Ώۂ̃p[c̒Pʍs傫Œŕ\)
                Matrix PickMatrix = Matrix.Identity;

                if (sbN.{fBA == this.]Ώ ) // {fBI
                {
                    PickMatrix = this.RobotUnit[0].Body.Pʍs;

                    // {fBW`̒S(p[cIĂȂꍇ)
                    camera.SetModelCenter( this.RobotUnit[0].Body.pos );	// w̍W`̒SƂ
                }
                else if (sbN.{fBB == this.]Ώ) // {fBI
                {
                    PickMatrix = this.RobotUnit[0].Body.PʍsBA;

                    // {fBW`̒S(p[cIĂȂꍇ)
                    camera.SetModelCenter(this.RobotUnit[0].Body.pos);	// w̍W`̒SƂ
                }
                else if ( sbN.p[c == this.]Ώ) // p[cI
                {
                    PickMatrix = this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].parts;

                    // sbNp[c(]Ώ)`̒S
                    Matrix vm = this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].֐ߍs;
                    // [hW x:M41 y:M42 z:M43
                    camera.SetModelCenter(new Vector3(vm.M41, vm.M42, vm.M43));	// w̍W`̒SƂ
                }


                // ----------------------------------------------------------
                // {bgUnit\

                if( this.b̎ )
                {
                    // ̎\
                    // radY=@̎pYW]pWA:f̕Е]B
                    /*
                    this.RobotUnit[0].DrawAAA(device, camera, this.iPickArm, this.iPickPart, new Vector3( fԊu, 0.0f, 16.0f), radY);
                    this.RobotUnit[0].DrawAAA(device, camera, this.iPickArm, this.iPickPart, new Vector3(-fԊu, 0.0f, 16.0f), 0);
                    */
/*
                    this.RobotUnit[0].Draw̎(device, camera, this.iPickArm, this.iPickPart, new Vector3( fԊu, 0.0f, J), radY);
                    this.RobotUnit[0].Draw̎(device, camera, this.iPickArm, this.iPickPart, new Vector3(-fԊu, 0.0f, J), 0);
*/
                    this.RobotUnit[0].Draw̎(device, camera, new Vector3( fԊu, 0.0f, J), radY );
                    this.RobotUnit[0].Draw̎(device, camera, new Vector3(-fԊu, 0.0f, J), 0    );

                }
                else
                {
                    // ʏ\
                    this.RobotUnit[0].Draw(device, camera, this.]Ώ, this.iPickArm, this.iPickPart);

                    // Ip[c̉]W\
                    if ( isHelpShowing )
                    {
                        device.RenderState.Lighting = false;
//                      this.Axis.Draw\ʒuw(device, camera, new Vector3(7.0f,  -7.0f, 28.0f ), PickMatrix);
                        this.Axis.Draw\ʒuw(device, camera, new Vector3(0.05f, -0.05f, 0.28f), PickMatrix);

                        device.RenderState.Lighting = true;
                    }
                }

                if (this.bUI\)
                {
                    // Show frame rate
                    RenderText();
                }



                // Show UI
                hud.OnRender(elapsedTime);
                sampleUi.OnRender(elapsedTime);
            }
            finally
            {
                if (beginSceneCalled)
                    device.EndScene();
            }
        }











        /// <summary>
        /// Render the help and statistics text. This function uses the Font object for 
        /// efficient text rendering.
        /// </summary>
        private void RenderText()
        {
//          Matrix m;

            TextHelper txtHelper = new TextHelper(statsFont, textSprite, 15);

            // Output statistics
            txtHelper.Begin();
            txtHelper.SetInsertionPoint(5, 5);
            txtHelper.SetForegroundColor(System.Drawing.Color.Yellow);

//          txtHelper.DrawTextLine(String.Format("eNX`p^[:{0:d}", this.RobotUnit[0].Body.m_eNX`p^[));

/*
            // ]Ώ -1:I -2:{fBI 0:p[cI
            txtHelper.DrawTextLine("Ip[cPʍs");
            if ( sbN.p[c != this.]Ώ )
                m = Matrix.Zero;
            else
                m = this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].Pʍs;
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44));
*/

//          txtHelper.DrawTextLine(String.Format("̑:{0:d},{1,7:F4}", ̑W, ̑ang));

/*
            txtHelper.DrawTextLine("parts");
            if (-1 == this.iPickArm)
                m = Matrix.Identity;
            else
                m = this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].parts;
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44));
*/


/*
            txtHelper.DrawTextLine("rotationSnapshot");
            m = this.CgRg[.rotationSnapshot;
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44));

            txtHelper.DrawTextLine("exM");
            m = this.CgRg[.exM;
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44));

            txtHelper.DrawTextLine("}EXPʍs");
            m = this.}EXPʍs;
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44));

            Vector3 v3 = new Vector3();
            txtHelper.DrawTextLine("CgRg[.currentDir");
            v3 = this.CgRg[.currentDir;
            txtHelper.DrawTextLine(String.Format("currentDir:{0,7:F4},{1,7:F4},{2,7:F4}", v3.X, v3.Y, v3.Z));
*/


/*
            m = new Matrix();
            txtHelper.DrawTextLine( "WorldMatrix" );
            m = camera.WorldMatrix;
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44));

            txtHelper.DrawTextLine( "ViewMatrix" );
            m = camera.ViewMatrix;
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34));
            txtHelper.DrawTextLine(String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44));
*/ 



/*
            Vector3 v3 = new Vector3();
            txtHelper.DrawTextLine("camera.EyeLocation");
            v3 = camera.EyeLocation;
            txtHelper.DrawTextLine(String.Format("Eye:{0,7:F4},{1,7:F4},{2,7:F4}", v3.X, v3.Y, v3.Z ));
*/


            // Draw help
            if (isHelpShowing)
            {
                txtHelper.DrawTextLine(sampleFramework.FrameStats);
                txtHelper.DrawTextLine(sampleFramework.DeviceStats);

                txtHelper.SetForegroundColor(System.Drawing.Color.White);

                // Boky.pos W
                txtHelper.DrawTextLine(String.Format("pos:{0,7:F3},{1,7:F3},{2,7:F3}",
                    this.RobotUnit[0].Body.pos.X,
                    this.RobotUnit[0].Body.pos.Y,
                    this.RobotUnit[0].Body.pos.Z));

                if(this.bXmlAj)
                {
                    txtHelper.DrawTextLine(String.Format("Aj|[YJE^:{0:d}", this.xml|[YJE^));
                }

                if (this.b̎)
                {
                    // @̎p
                    txtHelper.DrawTextLine(String.Format("̎ p:{0,6:F2} fԊu:{1,6:F2} J:{2,6:F2}",
                                                          this.angY,              this.fԊu,   this.J) );

                    txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height - 15 * 8);
                    txtHelper.SetForegroundColor(System.Drawing.Color.White);
                    txtHelper.DrawTextLine("Controls (F1 to hide):");

                    txtHelper.SetInsertionPoint(40, sampleFramework.BackBufferSurfaceDescription.Height - 15 * 7);
                    txtHelper.DrawTextLine("Quit: Esc");

                    txtHelper.DrawTextLine("̎p: 7/9");
                    txtHelper.DrawTextLine("f̊Ԋu: 4/6");
                    txtHelper.DrawTextLine("J: 1/3");

                    txtHelper.SetForegroundColor(System.Drawing.Color.White);
                    txtHelper.DrawTextLine("Hide help: F1");
                    txtHelper.DrawTextLine("UI\: H / |[YAj:A");

                }
                else
                {
                    // ]Ώ
                    if ( sbN.I == this.]Ώ)
                    {
                        txtHelper.DrawTextLine("]Ώ:I");
                    }
                    else if ( sbN.{fBA == this.]Ώ)
                    {
                        txtHelper.DrawTextLine("]Ώ:{fBA");
                    }
                    else if ( sbN.{fBB == this.]Ώ)
                    {
                        txtHelper.DrawTextLine("]Ώ:{fBB");
                    }
                    else if ( sbN.p[c == this.]Ώ)
                    {
                        txtHelper.DrawTextLine("]Ώ:p[c= Arm:" + this.iPickArm.ToString() + " / Part:" + this.iPickPart.ToString());
                    }


                    if (sbN.{fBB == this.]Ώ)
                    {
                        // {fBB() y]̂
                        txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height - 15 * 8);
                        txtHelper.SetForegroundColor(System.Drawing.Color.White);
                        txtHelper.DrawTextLine("Controls (F1 to hide):");

                        txtHelper.SetInsertionPoint(40, sampleFramework.BackBufferSurfaceDescription.Height - 15 * 7);
                        txtHelper.DrawTextLine("Quit: Esc");

                        txtHelper.DrawTextLine("Oi: x/z");

                        txtHelper.SetForegroundColor(System.Drawing.Color.GreenYellow);
                        txtHelper.DrawTextLine("y]: 4/6");

                        txtHelper.SetForegroundColor(System.Drawing.Color.White);
                        txtHelper.DrawTextLine("Hide help: F1");
                        txtHelper.DrawTextLine("UI\: H / |[YAj:A");
                    }
                    else
                    {
                        txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height - 15 * 8);
                        txtHelper.SetForegroundColor(System.Drawing.Color.White);
                        txtHelper.DrawTextLine("Controls (F1 to hide):");

                        txtHelper.SetInsertionPoint(40, sampleFramework.BackBufferSurfaceDescription.Height - 15 * 7);
                        txtHelper.DrawTextLine("Quit: Esc");

                        txtHelper.DrawTextLine("Oi: x/z");

                        txtHelper.SetForegroundColor(System.Drawing.Color.Red);
                        txtHelper.DrawTextLine("x]: 8/2");

                        //                  txtHelper.SetForegroundColor(System.Drawing.Color.Green);
                        txtHelper.SetForegroundColor(System.Drawing.Color.GreenYellow);
                        txtHelper.DrawTextLine("y]: 4/6");

                        //                  txtHelper.SetForegroundColor(System.Drawing.Color.Blue);
                        txtHelper.SetForegroundColor(System.Drawing.Color.DarkTurquoise);
                        txtHelper.DrawTextLine("z]: 1/3");

                        txtHelper.SetForegroundColor(System.Drawing.Color.White);
                        txtHelper.DrawTextLine("Hide help: F1");
                        txtHelper.DrawTextLine("UI\: H / |[YAj:A");

                    }



                }
            }
            else
            {
                txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height-15*2);
                txtHelper.SetForegroundColor(System.Drawing.Color.White);
                txtHelper.DrawTextLine("Press F1 for help");
            }
            txtHelper.End();
        }





        // p[c}EX + L[͂Ɨ
        // robotPartNX.m_parts ČvZ
        private void p[cRg[ČvZ()
        {
            if (0 == this.iPickPart)
                this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].Setupep[cs(); // {fBtp[c
            else
                this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].Setupqp[cs(); // p[ctp[c

            // *****************
            p[cRg[.arc.CurrentQuaternion = Quaternion.Identity;
            p[cRg[.rotation = Matrix.Identity;
            p[cRg[.rotationSnapshot = Matrix.Identity;

            this.}EXp[cs = this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].parts;
            Vector3 v3 = new Vector3(-}EXp[cs.M31, -}EXp[cs.M32, -}EXp[cs.M33);
            v3.Normalize();
            p[cRg[.LightDirection = v3; // p[c̐ݒ 
            // *****************

            p[cRg[.UpdateLightDirection();  // exM}gbNXXV
        }










        /// <summary>
        /// As a convenience, the sample framework inspects the incoming windows messages for
        /// keystroke messages and decodes the message parameters to pass relevant keyboard
        /// messages to the application.  The framework does not remove the underlying keystroke 
        /// messages, which are still passed to the application's MsgProc callback.
        /// </summary>
        private void OnKeyEvent(object sender, System.Windows.Forms.KeyEventArgs e)
        {
//          float ang = (float)(1.0f * Math.PI / 180);  // 1Pʂŉ]
            float ang = (float)(Math.PI / 128);         // 180128

            if (b̎)
            {
                // @̎\
                switch (e.KeyCode)
                {
                    // @̎pYW]p
                    case System.Windows.Forms.Keys.NumPad7:
                        angY = angY + 0.1f;
                        radY = (float)(angY * Math.PI / 180);
                        break;
                    case System.Windows.Forms.Keys.NumPad9:
                        angY = angY - 0.1f;
                        radY = (float)(angY * Math.PI / 180);
                        break;

                    // EfԊu 
                    case System.Windows.Forms.Keys.NumPad4:
                        fԊu = fԊu + 0.01f; 
                        break;
                    case System.Windows.Forms.Keys.NumPad6:
                        fԊu = fԊu - 0.01f;
                        break;

                    // f\TCY 
                    case System.Windows.Forms.Keys.NumPad1:
                        J = J + 0.1f; 
                        break;
                    case System.Windows.Forms.Keys.NumPad3:
                        J = J - 0.1f; 
                        break;
                }
            }
            else
            {
                // ̎łȂΑIp[c]
                switch (this.]Ώ)
                {
                    case sbN.{fBA:
                        switch (e.KeyCode)
                        {
                            case System.Windows.Forms.Keys.NumPad8:
                                this.RobotUnit[0].Body.RotateX_Pitch(ang);
                                break;
                            case System.Windows.Forms.Keys.NumPad2:
                                this.RobotUnit[0].Body.RotateX_Pitch(-ang);
                                break;

                            case System.Windows.Forms.Keys.NumPad4:
                                this.RobotUnit[0].Body.RotateY_Yaw(ang);
                                break;
                            case System.Windows.Forms.Keys.NumPad6:
                                this.RobotUnit[0].Body.RotateY_Yaw(-ang);
                                break;

                            case System.Windows.Forms.Keys.NumPad1:
                                this.RobotUnit[0].Body.RotateZ_Roll(ang);
                                break;
                            case System.Windows.Forms.Keys.NumPad3:
                                this.RobotUnit[0].Body.RotateZ_Roll(-ang);
                                break;
                        }
                        break;


                    case sbN.{fBB:
                        ang = (float)( Math.PI / 16 );
                        switch (e.KeyCode)
                        {
                            case System.Windows.Forms.Keys.NumPad4:
                                this.RobotUnit[0].Body.RotateY_YawB( ang);
                                break;
                            case System.Windows.Forms.Keys.NumPad6:
                                this.RobotUnit[0].Body.RotateY_YawB(-ang);
                                break;
                        }
                        break;

// ccc OnKeyEvent
                    case  sbN.p[c: // p[c

                        // p[cIĂꍇ
                        switch (e.KeyCode)
                        {
                            case System.Windows.Forms.Keys.NumPad8:
                                this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].RotateX_Pitch(ang);
                                p[cRg[ČvZ(); // p[c}EX + L[͂Ɨ
                                break;

                            case System.Windows.Forms.Keys.NumPad2:
                                this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].RotateX_Pitch(-ang);
                                p[cRg[ČvZ();
                                break;

                            case System.Windows.Forms.Keys.NumPad4:
                                this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].RotateY_Yaw(ang);
                                p[cRg[ČvZ();
                                break;
                            case System.Windows.Forms.Keys.NumPad6:
                                this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].RotateY_Yaw(-ang);
                                p[cRg[ČvZ();
                                break;

                            case System.Windows.Forms.Keys.NumPad1:
                                this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].RotateZ_Roll(ang);
                                p[cRg[ČvZ();
                                break;
                            case System.Windows.Forms.Keys.NumPad3:
                                this.RobotUnit[0].Arm[this.iPickArm].Parts[this.iPickPart].RotateZ_Roll(-ang);
                                p[cRg[ČvZ();
                                break;
                        }


                        break;
                } // switch (this.]Ώ)

            }


            switch(e.KeyCode)
            {
                // wv\
                case System.Windows.Forms.Keys.F1:
                    isHelpShowing = !isHelpShowing;
                    break;

                // Unit.i(ړ)
                case System.Windows.Forms.Keys.X:
                    this.RobotUnit[0].Body.i( 0.1f);  // Oi
                    break;

                case System.Windows.Forms.Keys.Z:
                    this.RobotUnit[0].Body.i(-0.1f);  // Oi
                    break;

                // -----------------------------------
                // UI\ off
                case System.Windows.Forms.Keys.H:
                    this.bUI\ = !bUI\;

                    if (!bUI\)
                    {
                        // UI̓eS폜
                        this.hud.RemoveAllControls();
                        this.sampleUi.RemoveAllControls();
                    }
                    else
                    {
                        // UIݒ肵\B
                        this.UIݒ();
                    }
                    break;

                // AL[:Aj[V(UI\off̎p)
                case System.Windows.Forms.Keys.A:
                    this.On|[YAj(sender,e);
                    break;


                // E[0] [1] ]
                case System.Windows.Forms.Keys.W:
                    this.EA[]();
                    break;


                default:
                    // UI\off̏ꍇꂩ̃L[͂ONɂB
                    if ( !bUI\ )
                    {
                        this.bUI\ = true;
                        this.UIݒ();
                    }
                    break;
            }

        
        }

        /// <summary>
        /// Before handling window messages, the sample framework passes incoming windows 
        /// messages to the application through this callback function. If the application sets 
        /// noFurtherProcessing to true, the sample framework will not process the message
        /// </summary>
        public IntPtr OnMsgProc(IntPtr hWnd, NativeMethods.WindowMessage msg, IntPtr wParam, IntPtr lParam, ref bool noFurtherProcessing)
        {
            // Give the dialog a chance to handle the message first
            noFurtherProcessing = hud.MessageProc(hWnd, msg, wParam, lParam);
            if (noFurtherProcessing)
                return IntPtr.Zero;

            noFurtherProcessing = sampleUi.MessageProc(hWnd, msg, wParam, lParam);
            if (noFurtherProcessing)
                return IntPtr.Zero;

            /*
             * ~hhbO
             *  p[cI:p[c]
             *  I    :Cg]
             */
            if( sbN.I == this.]Ώ )
            {
                CgRg[.HandleMessages(hWnd, msg, wParam, lParam);
            }
            else if ( sbN.p[c == this.]Ώ)
            {
                p[cRg[.HandleMessages(hWnd, msg, wParam, lParam);
            }

            // Pass all remaining windows messages to camera so it can respond to user input
            camera.HandleMessages(hWnd, msg, wParam, lParam);

            // }EX J[\ʒu 擾
            mouseX = NativeMethods.LoWord((uint)lParam.ToInt32());
            mouseY = NativeMethods.HiWord((uint)lParam.ToInt32());


            return IntPtr.Zero;
        }

        /// <summary>
        /// Initializes the application
        /// </summary>
        public void InitializeApplication()
        {

            // -----------------------------------------------
            // Q[ݒ̓Ǎ"MyRobot.config"

            this.RobotUnit = new robotUnit[1];
            for (int i = 0; i < this.RobotUnit.Length; i++)
            {
                this.RobotUnit[i] = null;
                this.RobotUnit[i] = new robotUnit();
            }
            this.RobotAnimeJn = new robotUnit[1];
            for (int i = 0; i < this.RobotAnimeJn.Length; i++)
            {
                this.RobotAnimeJn[i] = null;
                this.RobotAnimeJn[i] = new robotUnit();
            }
            this.RobotAnimeڕW = new robotUnit[1];
            for (int i = 0; i < this.RobotAnimeڕW.Length; i++)
            {
                this.RobotAnimeڕW[i] = null;
                this.RobotAnimeڕW[i] = new robotUnit();
            }


            try
            {
                //ۑ̃t@C (exẽtpX擾ÃfBNg𓾂)
                string fileName = System.IO.Path.GetDirectoryName(System.Windows.Forms.Application.ExecutablePath)
                                    + "\\" + "MyRobot.config";

                //XMLt@Cǂݍށ
                //XmlSerializerIuWFNg̍쐬
                System.Xml.Serialization.XmlSerializer serializer2 =
                    //                  new System.Xml.Serialization.XmlSerializer(typeof(robotUnit));
                    new System.Xml.Serialization.XmlSerializer(typeof(config));

                //t@CJ
                System.IO.FileStream fs2 = new System.IO.FileStream(fileName, System.IO.FileMode.Open);

                //XMLt@Cǂݍ݁AtVA
                //              this.RobotUnit[0] = (robotUnit)serializer2.Deserialize(fs2);
                this.config = (config)serializer2.Deserialize(fs2);


                // ----------------------------
                // configNXvOeǍ
                // @̎l
                this.angY = config.angY;  // x
                this.radY = config.radY;  // WA

                this.fԊu = config.fԊu;
                this.J = config.J;

                this.iwiF = config.iwiF;


                // \f
                this.RobotUnit[0] = config.RobotUnit;

                // --------------------------------------------
                // er̊ep[c̐ep[cĐݒ肷
                for (int i = 0; i < this.RobotUnit[0].Arm.Length; i++)
                {
                    this.RobotUnit[0].Arm[i].efݒ();
                }
                
                // {fB [hWʒu
                this.RobotUnit[0].Body.pos = new Vector3(0, 0, 0);

                // 3:f`t@C̓ǍɂIꂽeNX`p^[̏ꍇ͏
                // (f`݂Ȃ\邽߁B)
                if ( 4 == this.RobotUnit[0].Body.m_eNX`p^[ )
                {
                    this.RobotUnit[0].Body.m_eNX`p^[ = 0;
                }


                //
                fs2.Close();

                // .configǂݍ߂ꍇAbFirstRun͍̏sȂ
//              this.bFirstRun = false;
            }
            catch
            {
                // OAǂݍ܂Ȃ
            }


            // -----------------------------------------------
            // @̎pYW]p
            radY = (float)(angY * Math.PI / 180);


            UIݒ();   // UI(_CAO)ݒ

            CgRg[ = new DirectionWidget();
            p[cRg[ = new DirectionWidget();

            // ! Direction = new Vector3(0,-1,0); Ɩ󂪕\ȂB
            Vector3 v3 = new Vector3(0.4285f, 0.7673f, -0.3430f);
            v3.Normalize();
            CgRg[.LightDirection = v3;	// Cg̐ݒ 
            p[cRg[.LightDirection = v3;	// p[c̏lݒ 
        }














        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
        // xml Aj eXg2
        // XmlTextWriter + DOMdl
        // eXgp gp
        private void xmlAjeXg2(Device device)
        {
            XMLAnime anime = new XMLAnime();
/*
            AnimePart animePart = new AnimePart("E:\\!MyRobot\\MyRobot\\xml\\O.xml", 60, new Vector3(0, 0, 0));

            anime.Add(animePart);
            anime.Add(new AnimePart("E:\\!MyRobot\\MyRobot\\xml\\a0.xml", 30, new Vector3(0, 0, 0)));
            anime.Add(new AnimePart("E:\\!MyRobot\\MyRobot\\xml\\a1.xml", 20, new Vector3(0, 0, 0)));
            anime.Add(new AnimePart("E:\\!MyRobot\\MyRobot\\xml\\a2.xml", 40, new Vector3(0, 0, 0)));
            anime.Add(new AnimePart("E:\\!MyRobot\\MyRobot\\xml\\a3.xml", 80, new Vector3(0.1f, 0.2f, 0.3f)));
 */
/*
            AnimePart animePart = new AnimePart("O.xml", 60, new Vector3(0, 0, 0));

            anime.Add(animePart);
            anime.Add(new AnimePart("a0.xml", 30, new Vector3(0, 0, 0)));
            anime.Add(new AnimePart("a1.xml", 20, new Vector3(0, 0, 0)));
            anime.Add(new AnimePart("a2.xml", 40, new Vector3(0, 0, 0)));
            anime.Add(new AnimePart("a3.xml", 80, new Vector3(0.1f, 0.2f, 0.3f)));

            // Ajt@CtH_̑΃pXw : ok?
            anime.Add(new AnimePart("..\\xml\\a3.xml", 80, new Vector3(0.1f, 0.2f, 0.3f)));
*/
            AnimePart animePart = new AnimePart("..\\xml\\O.xml", 60, new Vector3(0, +1.0f, 0));

            anime.Add(animePart);
            anime.Add(new AnimePart("..\\xml\\a0.xml", 30, new Vector3(0, 0, 0)));
            anime.Add(new AnimePart("..\\xml\\a1.xml", 20, new Vector3(0, 0, 0)));
            anime.Add(new AnimePart("..\\xml\\a2.xml", 40, new Vector3(0, 0, 0)));
            anime.Add(new AnimePart("..\\xml\\a3.xml", 80, new Vector3(0, 0, 0)));

            anime.Add(new AnimePart("E:\\!MyRobot\\MyRobot\\xml\\a0.xml", 30, new Vector3(0, -1.0f, 0)));

            // 1.ۑ-----------------

            // ---------------
            //          http://dobon.net/vb/dotnet/file/getabsolutepath.html
            //          ΃pX΃pX擾A΃pX瑊΃pX擾
            Uri u1, u2;

            //x[XƂȂpX (exẽtpX擾ÃfBNg𓾂)
            u1 = new Uri(System.IO.Path.GetDirectoryName(System.Windows.Forms.Application.ExecutablePath));

            // u1x[XƂ
            // "..\\..\\anime"̐΃pX擾
            u2 = new Uri(u1, @"..\\anime");

            // u2.LocalPath:[J Iy[eBO VXeł̃t@C\擾
            string fileName1 = u2.LocalPath + "\\" + "MyRobot.an2";

            // WRITE
            XmlTextWriter xtw = new System.Xml.XmlTextWriter(fileName1, System.Text.Encoding.UTF8);
            xtw.Formatting = Formatting.Indented;	// Cfgďo 

            // Starts a new document 
            xtw.WriteStartDocument();// o[W "1.0"  XML 錾 
            xtw.WriteComment("MyRobotAj[V`t@C");	// Rg	

            // PersonalData
            xtw.WriteStartElement("root");	// Jn^O

            xtw.WriteComment("|[Yt@C  t[  ΈړW(x,y,z)");	// Rg	

            for (int i = 0; i < anime.Count; i++)
            {
                animePart = (AnimePart)anime.AnimeList[i];

                xtw.WriteStartElement("AnimePart");	// Jn^O
                {
                    xtw.WriteAttributeString("|[Yt@C", animePart.|[Yt@C.ToString());	// w肵l̑
                    xtw.WriteAttributeString("t[", animePart.t[.ToString());	// w肵l̑

                    xtw.WriteAttributeString("x", animePart.ΈړW.X.ToString());
                    xtw.WriteAttributeString("y", animePart.ΈړW.Y.ToString());
                    xtw.WriteAttributeString("z", animePart.ΈړW.Z.ToString());
                }
                xtw.WriteEndElement();	// I^O(AnimePart)
            }

            xtw.WriteEndElement();	// I^O(root)

            // EndDocument
            xtw.WriteEndDocument(); // JĂvf܂͑
            xtw.Close(); // ̃Xg[ъɂȂXg[



            // =====================================================
            // =====================================================

            // -------------------------------------------
            anime.Clear();  // NA
            // -------------------------------------------

            // =====================================================
            // =====================================================


            // 2.Ǎ-----------------
            //ۑ̃t@C (exẽtpX擾ÃfBNg𓾂)

            // XML DOM READ t@Cǂݍݗp
            XmlDocument doc = new XmlDocument();		// DOM hLg
            XmlNodeList nodeList;	// DOM m[hXg



            //x[XƂȂpX (exẽtpX擾ÃfBNg𓾂)
            u1 = new Uri(System.IO.Path.GetDirectoryName(System.Windows.Forms.Application.ExecutablePath));

            // u1x[XƂ
            // "..\\..\\anime"̐΃pX擾
            u2 = new Uri(u1, @"..\\anime");




            // u2.LocalPath:[J Iy[eBO VXeł̃t@C\擾
            string fileName2 = u2.LocalPath + "\\" + "MyRobot.an2";

            //fBNg̎擾
            string fBNg = System.IO.Path.GetDirectoryName(fileName2);

            // XMLt@C [h
            doc.Load(fileName2);

            // ========================================================================
            // <AnimePart |[Yt@C="E:\!MyRobot\MyRobot\xml\a0.xml" t[="30" x="0" y="0" z="0" />
            // <AnimePart |[Yt@C="E:\!MyRobot\MyRobot\xml\a1.xml" t[="20" x="0" y="0" z="0" />

            XmlAttributeCollection attrColl;
            XmlAttribute attr;

            string st;

            try
            {
                nodeList = doc.SelectNodes("//AnimePart"); // SelectNodes:XPath ƈvm[hXgI

                // foreach in [v: m[hXg ̃m[hɂđSď 
                foreach (XmlNode nd in nodeList)
                {
                    // w̑̒l擾
                    attrColl = nd.Attributes;

                    attr = (XmlAttribute)attrColl.GetNamedItem("|[Yt@C");
                    attr = (XmlAttribute)attrColl.GetNamedItem("t[");
                    attr = (XmlAttribute)attrColl.GetNamedItem("x");
                    attr = (XmlAttribute)attrColl.GetNamedItem("y");
                    attr = (XmlAttribute)attrColl.GetNamedItem("z");

                    string |[Yt@C = null;
                    int t[ = 30;
                    float x = 0;
                    float y = 0;
                    float z = 0;

                    // |[Yt@C:tpX擾Ċi[
                    attr = (XmlAttribute)attrColl.GetNamedItem("|[Yt@C");
                    |[Yt@C = attr.Value;

                    /*
                    |[Yt@C̑݃`FbN
                    1.|[Yt@C(΃pX)
                    2.Ajt@CfBNg+|[Yt@C(΃pX/fBNg)
                    */

                    // |[Yt@C΃pX擾
                    if ( !System.IO.File.Exists(|[Yt@C) )
                    {
                        // ݂Ȃ(΃pXł͖)
                        Uri url|[Yt@C = new Uri(fBNg + "\\" + |[Yt@C);

                        if (System.IO.File.Exists(url|[Yt@C.LocalPath))
                        {
                            // ݂
                            // |[Yt@C͑΃pXworfBNg
                            |[Yt@C = url|[Yt@C.LocalPath;   // ΃pX擾
                        }
                        else
                        {
                            // |[Yt@CȂBG[!!
                            throw (new Exception("\"" + |[Yt@C + "\"" + "܂B"));
                        }
                    }

                    attr = (XmlAttribute)attrColl.GetNamedItem("t[");
                    st = attr.Value;
                    t[ = System.Convert.ToInt32(st);

                    attr = (XmlAttribute)attrColl.GetNamedItem("x");
                    st = attr.Value;
                    x = (float)System.Convert.ToDouble(st) / t[;

                    attr = (XmlAttribute)attrColl.GetNamedItem("y");
                    st = attr.Value;
                    y = (float)System.Convert.ToDouble(st) / t[;

                    attr = (XmlAttribute)attrColl.GetNamedItem("z");
                    st = attr.Value;
                    z = (float)System.Convert.ToDouble(st) / t[;

                    anime.Add(new AnimePart(|[Yt@C, t[, new Vector3(x, y, z)));
                }


                // Aj[V̊Jn|[Y̕ۑ
                this.xmlRobotAnimeJn = new robotUnit[1];
                this.xmlRobotAnimeJn[0] = new robotUnit();
                this.xmlRobotAnimeJn[0] = (robotUnit)RobotUnit[0].Clone();  // N[쐬

                // t@Cǂݍ񂾃|[YփAj[Vňړ()
                // xmlύXAj̊Jn
                this.bXmlAj = true;
                this.xmlAjJE^ = 0;
                this.xml|[YJE^ = 0;

                // xmlRobotAnimeڕW 
                if (this.xmlRobotAnimeڕW != null)
                {
                    for (int i = 0; i < this.xmlRobotAnimeڕW.Length; i++)
                    {
//                      this.xmlRobotAnimeڕW[i].Dispose();
                        this.xmlRobotAnimeڕW[i] = null;
                    }
                }

                // RobotUnitAnimeڕW ݒ
                this.xmlRobotAnimeڕW = new robotUnit[anime.Count];

                // |[Ỹt[i[
                this.xmlAjt[ = null;
                this.xmlAjt[ = new int[anime.Count];

                this.xmlAjΈړW = null;
                this.xmlAjΈړW = new Vector3[anime.Count];

                this.xmlAjΈړW = null;
                this.xmlAjΈړW = new Vector3[anime.Count];

                // --------------------------------------------
                // |[Yt@CǍ
                for (int i = 0; i < this.xmlRobotAnimeڕW.Length; i++)
                {
                    // XMLAjt@Cɏꂽ|[Yt@CɓǍ
                    animePart = (AnimePart)anime.AnimeList[i];

                    this.xmlAjt[[i] = animePart.t[;
                    this.xmlAjΈړW[i] = animePart.ΈړW;
                    this.xmlAjΈړW[i] = animePart.ΈړW;

                    //ۑ̃t@C 
                    string |[Yt@C = animePart.|[Yt@C;

                    // |[Yt@Cǂݍݍς݂̏ꍇAēxǂݍ܂AȑOɓǂݍ񂾂̂gpB
                    // Ǎς?
                    bool bǍ = false;
                    for (int j = 0; j < i; j++)
                    {
                        AnimePart ǍanimePart = new AnimePart();

                        ǍanimePart = (AnimePart)anime.AnimeList[j];

                        if (ǍanimePart.|[Yt@C == |[Yt@C)
                        { 
                            // Ǎς݂̏ꍇV[Rs[
                            this.xmlRobotAnimeڕW[i] = this.xmlRobotAnimeڕW[j];
                            bǍ = true;
                        }
                    }
                    if (!bǍ)
                    { 
                        // Ǎς݂łȂ΁Aǂݍ
                        //--------------------------------
                        // |[Yt@CǍ
                        //XMLt@Cǂݍށ
                        //XmlSerializerIuWFNg̍쐬
                        System.Xml.Serialization.XmlSerializer serializer3 =
                            new System.Xml.Serialization.XmlSerializer(typeof(robotUnit));

                        //t@CJ
                        System.IO.FileStream fs3 = new System.IO.FileStream( |[Yt@C, System.IO.FileMode.Open);

                        // Aj[V̖ڕW|[Y̐ݒ
                        this.xmlRobotAnimeڕW[i] = null;
                        this.xmlRobotAnimeڕW[i] = new robotUnit();
                        this.xmlRobotAnimeڕW[i] = (robotUnit)serializer3.Deserialize(fs3);

                        //
                        fs3.Close();

                        // --------------------------------------------

                        // eNX`̐ݒ -> Aj[ṼeNX`̐ݒ:\=B
                        // Aj[V̊JnAIɃeNX`p^[ݒ肷B
                        //                  this.RobotUnit[0].Body.m_eNX`p^[ = RobotUnitAnimeڕW[i].Body.m_eNX`p^[;
                        //                  this.RobotUnit[0].Body.switcheNX`p^[(device);

                        // er̊ep[c̐ep[cĐݒ肷
                        for (int j = 0; j < this.xmlRobotAnimeڕW[i].Arm.Length; j++)
                        {
                            xmlRobotAnimeڕW[i].Arm[j].efݒ();
                        }
                        // CreateVB Ďs(tVAɂݒ肳ȂڂĐݒ)
//                      this.xmlRobotAnimeڕW[i].CreateVB(device);
//                      this.xmlRobotAnimeڕW[i].CreateVB(device, this.`Unit);
                    }
                } // for end |[Yt@CǍ


                // UI`FbN{bNXݒ(L/`FbN)
                // (Ǎꍇ)
                sampleUi.GetCheckbox(CheckBox3).IsEnabled = true;  // IsEnabled: t@CǍɗL
                sampleUi.GetCheckbox(CheckBox3).IsChecked = true;  // IsChecked:`FbN
                bXmlAjCheckBox = true;
            }
            catch (Exception e)
            {
                // tXN[łꍇAꎞB-> ĂуtXN[ 
//              if (!bWindowed) sampleFramework.ToggleFullscreen();

                // O:bZ[W{bNX\
                System.Windows.Forms.MessageBox.Show(
                        "G[:Ǎł܂łB\n"+e.Message +"\n"+ e.GetType().ToString(),
                        "MyRobot",
                        System.Windows.Forms.MessageBoxButtons.OK,
                        System.Windows.Forms.MessageBoxIcon.Error);
            }



        }

        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1











        /// <summary>
        /// UI(_CAO)ݒ
        /// </summary>
        private void UIݒ()
        {
            // hud ,sampleUi ݒ
            // -----------------------------------------------
            int y = 10;
            // Initialize the HUD
            Button fullScreen = hud.AddButton(ToggleFullscreen, "Toggle full screen", 35, y, 125, 22);
            Button toggleRef = hud.AddButton(ToggleReference, "Toggle reference (F3)", 35, y += 24, 125, 22);
            Button changeDevice = hud.AddButton(ChangeDevice, "Change Device (F2)", 35, y += 24, 125, 22);
            // Hook the button events for when these items are clicked
            fullScreen.Click += new EventHandler(OnFullscreenClicked);
            toggleRef.Click += new EventHandler(OnRefClicked);
            changeDevice.Click += new EventHandler(OnChangeDeviceClicked);

            // Now add the sample specific UI
            y = 10;

            const int Button1 = ChangeDevice + 10;
            sampleUi.AddButton(Button1, "|[Y", 60, y += 24, 100, 22);
            sampleUi.GetButton(Button1).Click += new EventHandler(On|[Y);

            const int Button2 = ChangeDevice + 20;
            sampleUi.AddButton(Button2, "|[Yۑ", 60, y += 24, 100, 22);
            sampleUi.GetButton(Button2).Click += new EventHandler(On|[Yۑ);

            const int Button3 = ChangeDevice + 30;
            sampleUi.AddButton(Button3, "|[YǍ", 60, y += 24, 100, 22);
            sampleUi.GetButton(Button3).Click += new EventHandler(On|[YǍ);

            const int Button35 = ChangeDevice + 35;
//          sampleUi.AddButton(Button35, "fǍ", 60, y += 24, 100, 22);
            sampleUi.AddButton(Button35, "fǍ", 60, y += 36, 100, 22);
            sampleUi.GetButton(Button35).Click += new EventHandler(OnfǍ);

            const int Button4 = ChangeDevice + 40;
            sampleUi.AddButton(Button4, "wp^[ؑ", 60, y += 24, 100, 22);
            sampleUi.GetButton(Button4).Click += new EventHandler(Onwp^[ؑ);

            const int Button5 = ChangeDevice + 50;
            sampleUi.AddButton(Button5, "eNX`ؑ", 60, y += 24, 100, 22);
            sampleUi.GetButton(Button5).Click += new EventHandler(OneNX`ؑ);

            const int Button6 = ChangeDevice + 60;
            sampleUi.AddButton(Button6, "|[YAj", 60, y += 24, 100, 22);
            sampleUi.GetButton(Button6).Click += new EventHandler(On|[YAj);

            const int Button7 = ChangeDevice + 70;
            sampleUi.AddButton(Button7, "AjǍ", 60, y += 24, 100, 22);
            sampleUi.GetButton(Button7).Click += new EventHandler(OnAjǍ);

            // ----------------------------------------
            // xmlAj
//          const int CheckBox3 = ChangeDevice + 75;
            CheckBox3 = ChangeDevice + 75;
            sampleUi.AddCheckBox(CheckBox3, "Aj", 65, y += 24, 125, 22, this.bXmlAj );
            sampleUi.GetCheckbox(CheckBox3).Changed += new EventHandler(OnAj);


            // UI\/\ ؑ֎ɃAj`FbN{bNX̗L/𕜌B
            sampleUi.GetCheckbox(CheckBox3).IsEnabled = bXmlAjCheckBox; // IsEnabled: t@CǍɗL

//          sampleUi.GetCheckbox(CheckBox3).IsEnabled = false; // IsEnabled: t@CǍɗL
//          sampleUi.GetCheckbox(CheckBox3).IsChecked = true;  // IsChecked:`FbN

            // ----------------------------------------
//          const int CheckBox1 = ChangeDevice + 80;
            CheckBox1 = ChangeDevice + 80;
            sampleUi.AddCheckBox(CheckBox1, "_̑", 65, y += 24, 125, 22, this.b̑);
            sampleUi.GetCheckbox(CheckBox1).Changed += new EventHandler(On̑);

            // ----------------------------------------
            const int CheckBox2 = ChangeDevice + 90;
            sampleUi.AddCheckBox(CheckBox2, "@̎", 65, y += 24, 125, 22, this.b̎ );
            sampleUi.GetCheckbox(CheckBox2).Changed += new EventHandler(On@̎);

            const int Button8 = ChangeDevice + 80;
            sampleUi.AddButton(Button8, "wiF", 60, y += 24, 100, 22);
            sampleUi.GetButton(Button8).Click += new EventHandler(OnwiF);

        }


        /// <summary>
        /// wiFݒ
        /// </summary>
        private void OnwiF(object sender, EventArgs e)
        {
            applicationState = ApplicationState.wiFݒ;
        }



        /// <summary>
        /// XML Aj[V `FbN{bNX.`FW
        /// ̃|[Yt@CŃAj̎s/~
        /// </summary>
        private void OnAj(object sender, EventArgs e)
        {
            this.bXmlAj = !this.bXmlAj;

            if (this.bXmlAj)
            {
                // `FbNꂽ
                // Aj[V̊Jn|[Y̍XV(_̕\Jn|[YƂ)
                this.xmlRobotAnimeJn = new robotUnit[1];
                this.xmlRobotAnimeJn[0] = new robotUnit();
                this.xmlRobotAnimeJn[0] = (robotUnit)RobotUnit[0].Clone();  // N[쐬

                // _̑ƃAj͗Ȃ̂off
                // ui:_̑ off
                sampleUi.GetCheckbox(CheckBox1).IsChecked = false;  // IsChecked:`FbN off
                this.b̑ = false;	// _̑~
            }

        }



        /// <summary>
        /// XML Aj[V t@CǍ
        /// ̃|[Yt@CŃAj[VB
        /// </summary>
        private void OnAjǍ(object sender, EventArgs e)
        {
            applicationState = ApplicationState.XMLAj;
        }



        /// <summary>
        /// xmlAj
        /// |[YȂǂxmlAj
        /// </summary>
        private void XMLAj()
        {
            // ui:xmlAj off
            sampleUi.GetCheckbox(CheckBox3).IsChecked = false;  // IsChecked:`FbN off
            this.bXmlAj = false;	// Aj~

            // JE^
            this.bXmlAj = false;
            this.xmlAjJE^ = 0;
            this.xml|[YJE^ = 0;
        }








        /// <summary>
        /// Aj[V`XMLt@CǍ
        /// XmlTextWriter + DOMdl
        /// </summary>
        /// <param name="device"></param>
        private void XMLAjǍ(Device device)
        {
            // e
            // 1.--- t@CI[v_CAO:Ajxmlw
            // 2.--- Ajxmlǂݍ
            // 3.--- AjxmlŎw肳ꂽ|[Yxml̓Ǎ

            // tXN[?
            bool bWindowed = sampleFramework.IsWindowed;

            // tXN[łꍇAꎞB
            if (!bWindowed) sampleFramework.ToggleFullscreen();



            // 1.--- t@CI[v_CAO:Ajxmlw
            // I[vt@C_CAO
            System.Windows.Forms.OpenFileDialog dialog = new System.Windows.Forms.OpenFileDialog();

            // tB^[XMLݒ
            dialog.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*";
            dialog.Title = "AjǍ";
//          dialog.InitialDirectory = System.Windows.Forms.Application.StartupPath + @"\..\..\anime";
            dialog.InitialDirectory = m_AjfBNg;


            // _CAO\
            if (System.Windows.Forms.DialogResult.OK == dialog.ShowDialog())
            {
                // ok ̏ꍇ XML t@C [h
                // -----------------------------------------------
                try
                {
                    // XML DOM READ t@Cǂݍݗp
                    XmlDocument doc = new XmlDocument();		// DOM hLg
                    XmlNodeList nodeList;	// DOM m[hXg
                    XmlNode     node;       // DOM m[h

                    XMLAnime anime = new XMLAnime();
                    AnimePart animePart = new AnimePart();

                    XmlAttributeCollection attrColl;
                    XmlAttribute attr;

                    string st;
                    string AjfileName = dialog.FileName;


                    // t@C I[v/Z[u _CAO NfBNg XV
                    m_AjfBNg = System.IO.Path.GetDirectoryName(AjfileName);

                    //fBNg̎擾
                    string fBNg = System.IO.Path.GetDirectoryName(AjfileName);

                    // 2.--- Ajxmlǂݍ
                    // XMLt@C [h
                    doc.Load(AjfileName);

                    // ========================================================================
                    // <f` file="ModelWMyRobot.xml" />
                    node = doc.SelectSingleNode("//f`");	// XPath ƈvŏ XmlNode I
                    if (null != node)   // m[hL?
                    {
                        attrColl = node.Attributes; // m[h擾
                        attr = (XmlAttribute)attrColl.GetNamedItem("file");
                        if (null != attr)   // L?
                        {
                            if ("" != attr.Value)
                            {
                                // f`ǂݍ
                                XMLfǍ(device, fBNg + "\\" + attr.Value );
                            }
                        }
                    }

                    // ========================================================================
                    // <AnimePart |[Yt@C="E:\!MyRobot\MyRobot\xml\a0.xml" t[="30" x="0" y="0" z="0" />
                    // <AnimePart |[Yt@C="E:\!MyRobot\MyRobot\xml\a1.xml" t[="20" x="0" y="0" z="0" />
                    nodeList = doc.SelectNodes("//AnimePart"); // SelectNodes:XPath ƈvm[hXgI


                    if (0 == nodeList.Count)
                    {
                        throw (new Exception( "Aj`xmlł͂Ȃ݂łB" ));
                    }


                    // foreach in [v: m[hXg ̃m[hɂđSď 
                    foreach (XmlNode nd in nodeList)
                    {
                        // w̑̒l擾
                        attrColl = nd.Attributes;

                        attr = (XmlAttribute)attrColl.GetNamedItem("|[Yt@C");
                        attr = (XmlAttribute)attrColl.GetNamedItem("t[");
                        attr = (XmlAttribute)attrColl.GetNamedItem("x");
                        attr = (XmlAttribute)attrColl.GetNamedItem("y");
                        attr = (XmlAttribute)attrColl.GetNamedItem("z");

                        string |[Yt@C = null;
                        int t[ = 30;

                        // ΈړWƐΈړWLꍇ́AΈړ݂̂s

                        // ΈړW
                        float x = 0;
                        float y = 0;
                        float z = 0;

                        // ΈړW(float.MinValue = ݒ)
                        float ax = float.MinValue;
                        float ay = float.MinValue;
                        float az = float.MinValue;

                        // |[Yt@C:tpX擾Ċi[
                        attr = (XmlAttribute)attrColl.GetNamedItem("|[Yt@C");
                        |[Yt@C = attr.Value;

                        /*
                        |[Yt@C̑݃`FbN
                        1.|[Yt@C(΃pX)
                        2.Ajt@CfBNg+|[Yt@C(΃pX/fBNg)
                        */

                        // |[Yt@C΃pX擾
                        if (!System.IO.File.Exists(|[Yt@C))
                        {
                            // ݂Ȃ(΃pXł͖)
                            Uri url|[Yt@C = new Uri(fBNg + "\\" + |[Yt@C);

                            if (System.IO.File.Exists(url|[Yt@C.LocalPath))
                            {
                                // ݂
                                // |[Yt@C͑΃pXworfBNg
                                |[Yt@C = url|[Yt@C.LocalPath;   // ΃pX擾
                            }
                            else
                            {
                                // |[Yt@CȂBG[!!
                                throw (new Exception("\"" + |[Yt@C + "\"" + "܂B"));
                            }
                        }

                        attr = (XmlAttribute)attrColl.GetNamedItem("t[");
                        if (null != attr)
                        {
                            st = attr.Value;
                            t[ = System.Convert.ToInt32(st);
                        }


                        // x,y,zSđ݂ꍇ̂݁Ax,y,z擾
                        if ((null != (XmlAttribute)attrColl.GetNamedItem("x")) &&
                            (null != (XmlAttribute)attrColl.GetNamedItem("y")) &&
                            (null != (XmlAttribute)attrColl.GetNamedItem("z")))
                        {
                            // ---------------------------------------------------
                            // ΈړW
                            attr = (XmlAttribute)attrColl.GetNamedItem("x");
                            if (null != attr)
                            {
                                st = attr.Value;
                                x = (float)System.Convert.ToDouble(st) / t[;
                            }

                            attr = (XmlAttribute)attrColl.GetNamedItem("y");
                            if (null != attr)
                            {
                                st = attr.Value;
                                y = (float)System.Convert.ToDouble(st) / t[;
                            }

                            attr = (XmlAttribute)attrColl.GetNamedItem("z");
                            if (null != attr)
                            {
                                st = attr.Value;
                                z = (float)System.Convert.ToDouble(st) / t[;
                            }
                        }


                        // ---------------------------------------------------
                        // ΈړWƐΈړWLꍇ́AΈړ݂̂s
                        // x,y,z݂Ȃꍇ̂,ax,ay,az擾
                        if ((null == (XmlAttribute)attrColl.GetNamedItem("x")) &&
                            (null == (XmlAttribute)attrColl.GetNamedItem("y")) &&
                            (null == (XmlAttribute)attrColl.GetNamedItem("z")))
                        {

                            // ax,ay,azSđ݂ꍇ̂݁Aax,ay,az擾
                            if ((null != (XmlAttribute)attrColl.GetNamedItem("ax")) &&
                                (null != (XmlAttribute)attrColl.GetNamedItem("ay")) &&
                                (null != (XmlAttribute)attrColl.GetNamedItem("az")))
                            {
                                // ΈړW
                                attr = (XmlAttribute)attrColl.GetNamedItem("ax");
                                if (null != attr)
                                {
                                    st = attr.Value;
                                    ax = (float)System.Convert.ToDouble(st);
                                }

                                attr = (XmlAttribute)attrColl.GetNamedItem("ay");
                                if (null != attr)
                                {
                                    st = attr.Value;
                                    ay = (float)System.Convert.ToDouble(st);
                                }

                                attr = (XmlAttribute)attrColl.GetNamedItem("az");
                                if (null != attr)
                                {
                                    st = attr.Value;
                                    az = (float)System.Convert.ToDouble(st);
                                }
                            }
                        }



//                      anime.Add(new AnimePart(|[Yt@C, t[, new Vector3(x, y, z)));
                        anime.Add(new AnimePart(    |[Yt@C,
                                                    t[,
                                                    new Vector3(x, y, z),       // ΈړW(D)
                                                    new Vector3(ax, ay, az)));  // ΈړW


                    } // end : foreach (XmlNode nd in nodeList)


                    // Aj[V̊Jn|[Y̕ۑ
                    this.xmlRobotAnimeJn = new robotUnit[1];
                    this.xmlRobotAnimeJn[0] = new robotUnit();
                    this.xmlRobotAnimeJn[0] = (robotUnit)RobotUnit[0].Clone();  // N[쐬

                    // t@Cǂݍ񂾃|[YփAj[Vňړ()
                    // xmlύXAj̊Jn
                    this.bXmlAj = true;
                    this.xmlAjJE^ = 0;
                    this.xml|[YJE^ = 0;


                    // _̑ƃAj͗Ȃ̂off
                    // ui:_̑ off
                    sampleUi.GetCheckbox(CheckBox1).IsChecked = false;  // IsChecked:`FbN off
                    this.b̑ = false;	// _̑~


                    // xmlRobotAnimeڕW 
                    if (this.xmlRobotAnimeڕW != null)
                    {
                        for (int i = 0; i < this.xmlRobotAnimeڕW.Length; i++)
                        {
//                          this.xmlRobotAnimeڕW[i].Dispose();
                            this.xmlRobotAnimeڕW[i] = null;
                        }
                    }

                    // RobotUnitAnimeڕW ݒ
                    this.xmlRobotAnimeڕW = new robotUnit[anime.Count];

                    // |[Ỹt[i[
                    this.xmlAjt[ = null;
                    this.xmlAjt[ = new int[anime.Count];

                    this.xmlAjΈړW = null;
                    this.xmlAjΈړW = new Vector3[anime.Count];

                    this.xmlAjΈړW = null;
                    this.xmlAjΈړW = new Vector3[anime.Count];

                    // --------------------------------------------
                    // 3.--- AjxmlŎw肳ꂽ|[Yxml̓Ǎ
                    // |[Yt@CǍ
                    for (int i = 0; i < this.xmlRobotAnimeڕW.Length; i++)
                    {
                        // XMLAjt@Cɏꂽ|[Yt@CɓǍ
                        animePart = (AnimePart)anime.AnimeList[i];

                        this.xmlAjt[[i] = animePart.t[;
                        this.xmlAjΈړW[i] = animePart.ΈړW;
                        this.xmlAjΈړW[i] = animePart.ΈړW;

                        //ۑ̃t@C 
                        string |[Yt@C = animePart.|[Yt@C;

                        // |[Yt@Cǂݍݍς݂̏ꍇAēxǂݍ܂AȑOɓǂݍ񂾂̂gpB
                        // Ǎς?
                        bool bǍ = false;

                        for (int j = 0; j < i; j++)
                        {
                            AnimePart ǍanimePart = new AnimePart();

                            ǍanimePart = (AnimePart)anime.AnimeList[j];

                            if (ǍanimePart.|[Yt@C == |[Yt@C)
                            {
                                // Ǎς݂̏ꍇV[Rs[
                                this.xmlRobotAnimeڕW[i] = this.xmlRobotAnimeڕW[j];
                                bǍ = true;
                            }
                        }


                        if (!bǍ)
                        {
                            // Ǎς݂łȂ΁Aǂݍ
                            //--------------------------------
                            // |[Yt@CǍ
                            //XMLt@Cǂݍށ
                            //XmlSerializerIuWFNg̍쐬
                            System.Xml.Serialization.XmlSerializer serializer3 =
                                new System.Xml.Serialization.XmlSerializer(typeof(robotUnit));

                            //t@CJ
                            System.IO.FileStream fs3 = new System.IO.FileStream(|[Yt@C, System.IO.FileMode.Open);

                            // Aj[V̖ڕW|[Y̐ݒ
                            this.xmlRobotAnimeڕW[i] = null;
                            this.xmlRobotAnimeڕW[i] = new robotUnit();
                            this.xmlRobotAnimeڕW[i] = (robotUnit)serializer3.Deserialize(fs3);

                            //
                            fs3.Close();

                            // --------------------------------------------

                            // eNX`̐ݒ -> Aj[ṼeNX`̐ݒ:\=B
                            // Aj[V̊JnAIɃeNX`p^[ݒ肷B
                            //                  this.RobotUnit[0].Body.m_eNX`p^[ = RobotUnitAnimeڕW[i].Body.m_eNX`p^[;
                            //                  this.RobotUnit[0].Body.switcheNX`p^[(device);

                            // er̊ep[c̐ep[cĐݒ肷
                            for (int j = 0; j < this.xmlRobotAnimeڕW[i].Arm.Length; j++)
                            {
                                xmlRobotAnimeڕW[i].Arm[j].efݒ();
                            }

                            // zzz xmlAjł͒Pʍŝ݂QƂ̂CreateVB/Dispose͍sȂ
//                          this.xmlRobotAnimeڕW[i].CreateVB(device);
                        }
                    } // for end |[Yt@CǍ


                    // UI`FbN{bNXݒ(L/`FbN)
                    // (Ǎꍇ)
                    sampleUi.GetCheckbox(CheckBox3).IsEnabled = true;  // IsEnabled: t@CǍɗL
                    sampleUi.GetCheckbox(CheckBox3).IsChecked = true;  // IsChecked:`FbN
                    bXmlAjCheckBox = true;

                }
                catch (Exception e)
                {
                    // tXN[łꍇAꎞB-> ĂуtXN[ 
                    if (!bWindowed) sampleFramework.ToggleFullscreen();

                    // O:bZ[W{bNX\
                    System.Windows.Forms.MessageBox.Show(
                            "G[:Ǎł܂łB" + e.Message, "MyRobot",
                            System.Windows.Forms.MessageBoxButtons.OK,
                            System.Windows.Forms.MessageBoxIcon.Error);
                }
                // -----------------------------------------------
            }

            // tXN[łꍇAꎞB-> ĂуtXN[ 
            if (!bWindowed) sampleFramework.ToggleFullscreen();

        }
        // end XMLAjǍ2() -------------------------------------------------------------------------















        /// <summary>
        /// @̎
        /// </summary>
        private void On@̎(object sender, EventArgs e)
        {
            this.b̎ = !b̎;
        }


        /// <summary>
        /// _̑
        /// </summary>
        private void On̑(object sender, EventArgs e)
        {
            this.b̑ = !b̑;

            if (b̑)
            {
                // `FbNꂽ̑eXV
                System.Random r = new System.Random();

                if (0 == r.Next(0, 2))
                    ̑ang = (float)(1.0f * Math.PI / 180);
                else
                    ̑ang = (float)(-1.0f * Math.PI / 180);

                ̑W = (uint)r.Next(1, 8); // 2̈̊Ԃ̗Ԃ(1-7)

                // --------
                XMLAj();	// Aj off/Jnʒu
            }

        }



        /// <summary>
        /// |[Y Aj[V
        /// </summary>
        private void On|[YAj(object sender, EventArgs e)
        {
            // Aj[V`撆Ȃ΋A
            if (this.bAj)
                return;

            // |[YύXAj̊Jn
            this.bAj = true;
            this.AjJE^ = 0;

            // Aj[V̊Jn|[Y̕ۑ
//            this.RobotAnimeJn[0].Dispose();
            this.RobotAnimeJn[0] = null;
            this.RobotAnimeJn[0] = new robotUnit();
            this.RobotAnimeJn[0] = (robotUnit)RobotUnit[0].Clone();  // N[쐬

            // --------
            XMLAj();	// Aj off/Jnʒu
        }


        /// <summary>
        /// eNX` p^[ؑ
        /// </summary>
        private void OneNX`ؑ(object sender, EventArgs e)
        {
            applicationState = ApplicationState.eNX`ؑ;
        }


        /// <summary>
        /// wp^[ؑ
        /// </summary>
        private void Onwp^[ؑ(object sender, EventArgs e)
        {
            if ( sbN.p[c == this.]Ώ) // ]Ώ:p[c
            {
                this.RobotUnit[0].Arm[this.iPickArm].wp^[ؑ();
            }
        }



        /// <summary>
        /// |[Y
        /// </summary>
        private void On|[Y(object sender, EventArgs e)
        {
            applicationState = ApplicationState.|[Y;

        }

        /// <summary>
        /// |[Yۑ
        /// </summary>
        private void On|[Yۑ(object sender, EventArgs e)
        {
            applicationState = ApplicationState.|[Yۑ;
        }

        /// <summary>
        /// |[YǍ
        /// </summary>
        private void On|[YǍ(object sender, EventArgs e)
        {
            applicationState = ApplicationState.|[YǍ;
        }


        /// <summary>
        /// fǍ
        /// </summary>
        private void OnfǍ(object sender, EventArgs e)
        {
            applicationState = ApplicationState.fǍ;
        }



        /// <summary>
        /// f`XMLt@CǍ_CAO
        /// </summary>
        private void XMLfǍ_CAO(Device device)
        {
            // e
            // 1.--- t@CI[v_CAO:fxmlw
            // 2.--- Ajxmlǂݍ
            // 3.--- AjxmlŎw肳ꂽ|[Yxml̓Ǎ

            // tXN[?
            bool bWindowed = sampleFramework.IsWindowed;

            // tXN[łꍇAꎞB
            if (!bWindowed) sampleFramework.ToggleFullscreen();

            // 1.--- t@CI[v_CAO:fxmlw
            // I[vt@C_CAO
            System.Windows.Forms.OpenFileDialog dialog = new System.Windows.Forms.OpenFileDialog();

            // tB^[XMLݒ
            dialog.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*";
            dialog.Title = "fǍ";
            dialog.InitialDirectory = m_ffBNg;

            // _CAO\
            if (System.Windows.Forms.DialogResult.OK == dialog.ShowDialog())
            {
                // ok ̏ꍇ XML t@C [h
                // -----------------------------------------------
                try
                {

                    XMLfǍ(device, dialog.FileName);

                }
                catch (Exception e)
                {
                    // tXN[łꍇAꎞB-> ĂуtXN[ 
                    if (!bWindowed) sampleFramework.ToggleFullscreen();

                    // O:bZ[W{bNX\
                    System.Windows.Forms.MessageBox.Show(
                            "G[:Ǎł܂łB" + e.Message, "MyRobot",
                            System.Windows.Forms.MessageBoxButtons.OK,
                            System.Windows.Forms.MessageBoxIcon.Error);
                }
                // -----------------------------------------------
            }
            // tXN[łꍇAꎞB-> ĂуtXN[ 
            if (!bWindowed) sampleFramework.ToggleFullscreen();
        }
        // end XMLfǍ_CAO() -------------------------------------------------------------------------



        
        
        
        
        /// <summary>
        /// f`XMLt@CǍ
        /// XmlTextWriter + DOMdl
        /// </summary>
        private void XMLfǍ(Device device, string FileName )
        {
            try
            {
                `Unit = new `Unit();  // `Unit

                this.`Unit.xmlfǍ(FileName);
                this.RobotUnit[0].Dispose();
                this.RobotUnit[0].f`eNX`ݒ(`Unit);
                this.RobotUnit[0].CreateVB(device, this.`Unit);

                // t@C I[v/Z[u _CAO NfBNg XV
                m_ffBNg = System.IO.Path.GetDirectoryName(FileName);

                // {fB:[hWʒu
                this.RobotUnit[0].Body.pos = new Vector3(0, 0, 0);

                // ------------------------------------------
                // f`t@CŎw肳ꂽ|[Y
                if (null != `Unit.|[Yt@C && "" != `Unit.|[Yt@C)
                {
                    //ۑ̃t@C
                    string fileName = this.`Unit.|[Yt@C;

                    //XMLt@Cǂݍށ
                    //XmlSerializerIuWFNg̍쐬
                    System.Xml.Serialization.XmlSerializer serializer2 =
                        new System.Xml.Serialization.XmlSerializer(typeof(robotUnit));

                    //t@CJ
                    System.IO.FileStream fs2 = new System.IO.FileStream(fileName, System.IO.FileMode.Open);

                    // t@Cǂݍ񂾃|[YփAj[Vňړ
                    // |[YύXAj̊Jn
                    this.bAj = true;
                    this.AjJE^ = 0;

                    // Aj[V̊Jn|[Y̕ۑ
//                    this.RobotAnimeJn[0].Dispose();
                    this.RobotAnimeJn[0] = null;
                    this.RobotAnimeJn[0] = new robotUnit();
                    this.RobotAnimeJn[0] = (robotUnit)RobotUnit[0].Clone();  // N[쐬

                    // Aj[V̖ڕW|[Y̐ݒ
//                    this.RobotAnimeڕW[0].Dispose();
                    this.RobotAnimeڕW[0] = null;
                    this.RobotAnimeڕW[0] = new robotUnit();
                    this.RobotAnimeڕW[0] = (robotUnit)serializer2.Deserialize(fs2);
                    // --------------------------------------------

                    // er̊ep[c̐ep[cĐݒ肷
                    for (int i = 0; i < this.RobotAnimeڕW[0].Arm.Length; i++)
                    {
                        RobotAnimeڕW[0].Arm[i].efݒ();
                    }
                    // CreateVB Ďs(tVAɂݒ肳ȂڂĐݒ)
//                    this.RobotAnimeڕW[0].CreateVB(device, this.`Unit);

                    //
                    fs2.Close();

                    // --------
                    XMLAj();	// Aj off/Jnʒu
                }
                // ------------------------------------------
            }
            catch (Exception e)
            {
                throw (e);
            }
        }
        // end XMLfǍ() -------------------------------------------------------------------------
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        // -----------------------------------------------------------
        // E[0] [1] ] sAj[V쐬Ɏgp
        private void EA[]()
        {
            robotArm tmpArm = new robotArm();
            Matrix m = Matrix.Zero;

            for (int i = 0; i < tmpArm.Parts.Length; i++)
            {
                m = this.RobotUnit[0].Arm[0].Parts[i].Pʍs;
                m.M12 = -m.M12;
                m.M13 = -m.M13;

                m.M21 = -m.M21;
                m.M31 = -m.M31;
                tmpArm.Parts[i].Pʍs = m;
            }

            for (int i = 0; i < tmpArm.Parts.Length; i++)
            {
                m = this.RobotUnit[0].Arm[1].Parts[i].Pʍs;
                m.M12 = -m.M12;
                m.M13 = -m.M13;

                m.M21 = -m.M21;
                m.M31 = -m.M31;
                this.RobotUnit[0].Arm[0].Parts[i].Pʍs = m;
            }

            for (int i = 0; i < tmpArm.Parts.Length; i++)
            {
                this.RobotUnit[0].Arm[1].Parts[i].Pʍs = tmpArm.Parts[i].Pʍs;
            }

        }

































        // --------------------------------------------------------------------------
        // --------------------------------------------------------------------------
        // sbN̔
        /*
            http://www.microsoft.com/japan/msdn/directx/japan/dx9/winform3.asp
            ǂ̃IuWFNg (邢̓|S) sbN̔ɂ́A
            NbNXN[ẄʒuAC (ːA) 𓊂āA
            IuWFNgƂ̌𒲂ׂ@悭g܂B

            ̂ƂAׂIuWFNgƃCƂ𓯂WԂŕ]Kv܂B
            ܂AMesh.Intersect \bhg΁AIuWFNgƃCƂ̌𒲂ׂ邱Ƃł܂A
            bVIuWFNg̓[JԂŒ`Ă̂ŁAC[JԂɍWϊKv܂B

            ̃Tvł́A܂ANbNXN[ʒuA
            r[|[gԓł̃NbNꂽ_̋ߕʏ̈ʒu (new Vector3(e.X, e.Y, vp.MinZ)) 
            Ɖʏ̈ʒu (new Vector3(e.X, e.Y, vp.MaxZ)) 𐶐܂B

            ɁAVector3.Unproject \bhgāA
            ꂼ̈ʒuIuWFNg̃[JԂɍWϊ܂ (vNear  vFar)B

            ꂩA[JԂł̃C̕xNg (vDir) 𐶐A
            Mesh.Intersect \bhgāA2 ̍WԃxNgƁA
            IuWFNgƂ̌𒲂ׂ܂B

            Intersect \bh true ԂAĂ܂ÃIuWFNgsbNĂ܂B

            ̃V[͒PȂ̂ŁAsɕ̃IuWFNgdȂ邱Ƃ͂܂񂪁A
            GȃV[ł́ÃIuWFNgCƌꍇ܂B
            ꍇ̂߂ɁAIntersect \bh[x擾邱Ƃ\łB
            ڂ SDK hLgQƂĂB
            ʏ́A[xԏ (܂AԎO) IuWFNgIׂ΂悢ł傤B
        */
        /// <summary>
        /// ]̑ΏۂƂȂ郁bVsbNo
        /// </summary>
        private void sbNo()
        {
            // sbNA}EXI[oop
            Matrix projMat = camera.ProjectionMatrix;   // es
            Matrix viewMat = camera.ViewMatrix;         // r[s
            Matrix worldMat = camera.WorldMatrix;		// [hs	

            float minDist = float.MaxValue; // XN[sbNΏۂ܂ł̋(߂̂ΏۂƂB)

            // r[|[g
            Viewport viewport = new Viewport();

            viewport.Width = this.windowWidth;
            viewport.Height = this.windowHeight;

            viewport.X = viewport.Y = 0;

            viewport.MaxZ = 1.0f;
            viewport.MinZ = 0.0f;

            // -1:I
            // -2:{fBI
            // 0`:p[cI
            this.iPickArm = -1;
            this.iPickPart = -1;

            this.]Ώ = sbN.I;


            // =============================================================================
            // =============================================================================

            // BodyA sbN ++++++++++++++++++++++++++++++++++++++++++++++++++++

            // {fBƂ̃sbN (ǉ)
            // NbNXN[W烌CvZAObhƂ̌`FbN 
            Vector3 vNear = Vector3.Unproject(
                new Vector3(mouseX, mouseY, viewport.MinZ), // r[|[gԓł̃NbNꂽ_̋ߕʏ̈ʒu
                viewport,
                projMat,
                viewMat,

                // +++++
                this.RobotUnit[0].Body.BodysA * worldMat); //s

            Vector3 vFar = Vector3.Unproject(
                new Vector3(mouseX, mouseY, viewport.MaxZ), // r[|[gԓł̃NbNꂽ_̉ʏ̈ʒu
                viewport,
                projMat,
                viewMat,

                // +++++
                this.RobotUnit[0].Body.BodysA * worldMat); //s

            Vector3 vDir = Vector3.Normalize(vFar - vNear);

            IntersectInformation closestHit = new IntersectInformation();

            // +++++
            if (this.RobotUnit[0].Body.meshA.Intersect(vNear, vDir, out closestHit))
            {
                if (minDist > closestHit.Dist)
                {
                    minDist = closestHit.Dist;
                    this.iPickArm  = -2;    // -2:{fBI
                    this.iPickPart = -2;
                    this.]Ώ  = sbN.{fBA;
                    camera.SetRadius(8.0f, 1.0f, 256.0f);   // J̋ default,min,max
                }
            }

            // BodyB sbN ++++++++++++++++++++++++++++++++++++++++++++++++++++

            // {fBƂ̃sbN (ǉ)
            // NbNXN[W烌CvZAObhƂ̌`FbN 
            vNear = Vector3.Unproject(
                new Vector3(mouseX, mouseY, viewport.MinZ), // r[|[gԓł̃NbNꂽ_̋ߕʏ̈ʒu
                viewport,
                projMat,
                viewMat,

                // +++++
                this.RobotUnit[0].Body.BodysBA * worldMat); //s

            vFar = Vector3.Unproject(
                new Vector3(mouseX, mouseY, viewport.MaxZ), // r[|[gԓł̃NbNꂽ_̉ʏ̈ʒu
                viewport,
                projMat,
                viewMat,

                // +++++
                this.RobotUnit[0].Body.BodysBA * worldMat); //s

            vDir = Vector3.Normalize(vFar - vNear);

            closestHit = new IntersectInformation();

            // +++++
            if (this.RobotUnit[0].Body.meshB.Intersect(vNear, vDir, out closestHit))
            {
                if (minDist > closestHit.Dist)
                {
                    minDist = closestHit.Dist;
                    this.iPickArm = -2;    // -2:{fBI
                    this.iPickPart = -2;
                    this.]Ώ = sbN.{fBB;
                    camera.SetRadius(8.0f, 1.0f, 256.0f);   // J̋ default,min,max
                }
            }


            // =============================================================================
            // =============================================================================
            // p[cƂ̃sbN
            // for r̖{(4{)
            //    for r̃p[c(13{)      
            for (int iArm = 0; iArm < this.RobotUnit[0].Arm.Length; iArm++)
            {
                for (int iParts = 0; iParts < this.RobotUnit[0].Arm[iArm].Parts.Length; iParts++)
                {
                    // =============================================================================
                    // =============================================================================

                    // NbNXN[W烌CvZAObhƂ̌`FbN 
                    vNear = Vector3.Unproject(
                        new Vector3(mouseX, mouseY, viewport.MinZ), // r[|[gԓł̃NbNꂽ_̋ߕʏ̈ʒu
                        viewport,
                        projMat,
                        viewMat,
                        this.RobotUnit[0].Arm[iArm].Parts[iParts].parts * worldMat); //s

                    vFar = Vector3.Unproject(
                        new Vector3(mouseX, mouseY, viewport.MaxZ), // r[|[gԓł̃NbNꂽ_̉ʏ̈ʒu
                        viewport,
                        projMat,
                        viewMat,
                        this.RobotUnit[0].Arm[iArm].Parts[iParts].parts * worldMat); //s
                    /*
                    Vector3.Unproject()
                    XN[ԂIuWFNgԂɃxNgˉe

                    p[^
                    v           Vector3:       ̊ɂȂ Vector3 \́B 
                    viewport    System.Object: r[|[g\ Object B 
                    projection  Matrix:        ˉes\ Matrix \́B 
                    view        Matrix:        r[s\ Matrix \́B 
                    world       Matrix:        [hs\ Matrix \́B 

                    ߂l
                    Microsoft.DirectX.Vector3BXN[ԂIuWFNgԂɎˉexNgł Vector3 \́B
                    */

                    vDir = Vector3.Normalize(vFar - vNear);

                    closestHit = new IntersectInformation();

                    if (this.RobotUnit[0].Arm[iArm].Parts[iParts].mesh.Intersect(vNear, vDir, out closestHit))
                    {
                        if (minDist > closestHit.Dist)
                        {
                            minDist = closestHit.Dist;  // XN[sbNΏۂ܂ł̋(߂̂ΏۂƂB)
                            // Yr̊Yp[csbN
                            // iArm iParts
                            this.iPickArm = iArm;
                            this.iPickPart = iParts;
                            this.]Ώ = sbN.p[c;  // ]Ώ:p[c

                            // J̋p[cɒ
                            float len = this.RobotUnit[0].Arm[iArm].Parts[iParts].axis.Length();
                            camera.SetRadius(len*8f, 1.0f, 256.0f);   // J̋ default,min,max
                        }
                    }
                    /*
                    Mesh.Intersect \bh
                    CbVɓ邩ǂ𔻕ʂ܂B
                                
                    p[^
                    rayPos      Vector3:C̎n_Ww肷 Vector3 \́B 
                    rayDir      Vector3:C̕w肷 Vector3 \́B 
                    closestHit  Direct3D.IntersectInformationB
                                zƃbV̊Ԃ̍ł߂_Lq IntersectInformation IuWFNgB 
                                
                    ߂l
                    System.BooleanBCbV̎Op`̖ʂɓꍇ trueAȊȌꍇ falseB
                    */

                    // =============================================================================
                    // =============================================================================
                }// for Pars end

            }// for Arm end



            /*
            {fB/p[cNbNƑI`撆SɂȂB
            ȂɂȂƂNbNƖIɂȂB-> `撆S͂̂܂܁B
            I̎ɂxȂɂȂƂNbNƕ`撆ŚAW_ɂȂB(J)
            */
            if ( sbN.I == this.]Ώ && sbN.I == this.O]Ώ)
            {
                camera.SetModelCenter(Vector3.Empty);	// w̍W`̒SƂ
                camera.SetRadius(8.0f, 1.0f, 256.0f);   // J̋ default,min,max
            }


            // ]Ώۂ{fB/p[c疢IɕωƂ
            // J̋𒲐
            if( this.]Ώ != this.O]Ώ )
            {
                this.O]Ώ = this.]Ώ;
            }










        }
        // --------------------------------------------------------------------------
        // --------------------------------------------------------------------------




        /// <summary>Called when the change device button is clicked</summary>
        private void OnChangeDeviceClicked(object sender, EventArgs e)
        {
            sampleFramework.ShowSettingsDialog(!sampleFramework.IsD3DSettingsDialogShowing);
        }

        /// <summary>Called when the full screen button is clicked</summary>
        private void OnFullscreenClicked(object sender, EventArgs e)
        {
            sampleFramework.ToggleFullscreen();
        }

        /// <summary>Called when the ref button is clicked</summary>
        private void OnRefClicked(object sender, EventArgs e)
        {
            sampleFramework.ToggleReference();
        }

        /// <summary>
        /// Entry point to the program. Initializes everything and goes into a message processing 
        /// loop. Idle time is used to render the scene.
        /// </summary>
        [STAThread()]   // System.STAThreadAttribute  w肵ȂSystem.Windows.Forms\fobOɗO
        static int Main() 
        {
            System.Windows.Forms.Application.EnableVisualStyles();
            using(Framework sampleFramework = new Framework())
            {
                MyRobot sample = new MyRobot(sampleFramework);
                // Set the callback functions. These functions allow the sample framework to notify
                // the application about device changes, user input, and windows messages.  The 
                // callbacks are optional so you need only set callbacks for events you're interested 
                // in. However, if you don't handle the device reset/lost callbacks then the sample 
                // framework won't be able to reset your device since the application must first 
                // release all device resources before resetting.  Likewise, if you don't handle the 
                // device created/destroyed callbacks then the sample framework won't be able to 
                // recreate your device resources.
                sampleFramework.Disposing += new EventHandler(sample.OnDestroyDevice);
                sampleFramework.DeviceLost += new EventHandler(sample.OnLostDevice);
                sampleFramework.DeviceCreated += new DeviceEventHandler(sample.OnCreateDevice);
                sampleFramework.DeviceReset += new DeviceEventHandler(sample.OnResetDevice);

                sampleFramework.SetWndProcCallback(new WndProcCallback(sample.OnMsgProc));

                sampleFramework.SetCallbackInterface(sample);
                try
                {
                    // Show the cursor and clip it when in full screen
                    sampleFramework.SetCursorSettings(true, true);

                    // Initialize
                    sample.InitializeApplication();

                    // Initialize the sample framework and create the desired window and Direct3D 
                    // device for the application. Calling each of these functions is optional, but they
                    // allow you to set several options which control the behavior of the sampleFramework.
                    sampleFramework.Initialize( true, true, true ); // Parse the command line, handle the default hotkeys, and show msgboxes
                    sampleFramework.CreateWindow("MyRobot");
                    // Hook the keyboard event
                    sampleFramework.Window.KeyDown += new System.Windows.Forms.KeyEventHandler(sample.OnKeyEvent);

                    // EBhETCYw肵Ă邪AŕςƂȂB
                    sampleFramework.CreateDevice( 0, true, Framework.DefaultSizeWidth, Framework.DefaultSizeHeight, 
                        sample);

                    // Pass control to the sample framework for handling the message pump and 
                    // dispatching render calls. The sample framework will call your FrameMove 
                    // and FrameRender callback when there is idle time between handling window messages.
                    sampleFramework.MainLoop();

                }
#if(DEBUG)
                catch (Exception e)
                {
                    // In debug mode show this error (maybe - depending on settings)
                    sampleFramework.DisplayErrorMessage(e);
#else
            catch
            {
                // In release mode fail silently
#endif
                    // Ignore any exceptions here, they would have been handled by other areas
                    return (sampleFramework.ExitCode == 0) ? 1 : sampleFramework.ExitCode; // Return an error code here
                }

                // Perform any application-level cleanup here. Direct3D device resources are released within the
                // appropriate callback functions and therefore don't require any cleanup code here.
                return sampleFramework.ExitCode;
            }
        }
    }
}
