using System;
using System.Windows.Forms;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

using Direct3D = Microsoft.DirectX.Direct3D;

namespace MyRobot
{
    /// <summary>
    /// {fB2
    /// </summary>
    public class robotBodyBase
    {
        private robotBodyPartA BodyA;    // {fB㕔()
        private robotBodyPartB BodyB;    // {fB({fB㕔ɐڑ)

        // px=Pʍs:[1,1][2,2][3,3][4,4] W 1 ݒ
        private Matrix m_Pʍs  = Matrix.Identity;   // Body㔼̒Pʍs
        private Matrix m_PʍsB = Matrix.Identity;   // Body̒Pʍs

        // ʒuW
        private Vector3 m_pos = new Vector3(0.0f, 0.0f, 0.0f);

        // f`t@Cǂݍ񂾃eNX`t@C(tpX)
        string m_textureOt@C = null;
        string m_texturet@C = null;

        string m_textureEt@C = null;
        string m_texturet@C = null;

        Texture textureO = null;
        Texture texture = null;
        Texture textureE = null;
        Texture texture = null;

        public  int m_eNX`p^[   = 0; // eNX`I
        private int m_eNX`p^[ = 4; // eNX`p^[ l:4 fǍ:5

        // ANZT ----------------------------------------------------------------------

        // eNX`ؑփ{^ɂؑ։\ȃp^[
        public int eNX`p^[
        {
            set { m_eNX`p^[ = value; }
        }

        // f`t@Cǂݍ񂾃eNX`t@C
        public string textureOt@C
        {
            set { m_textureOt@C = value; }
        }

        public string texturet@C
        {
            set { m_texturet@C = value; }
        }

        public string textureEt@C
        {
            set { m_textureEt@C = value; }
        }

        public string texturet@C
        {
            set { m_texturet@C = value; }
        }
        
        // ʒuW
        public Vector3 pos
        {
            get { return m_pos; }
            set { m_pos = value; }
        }

        // Pʍs (㔼)
        public Matrix Pʍs
        {
            get { return m_Pʍs; }
            set { m_Pʍs = value; }
        }

        // PʍsB ()
        public Matrix PʍsB
        {
            get { return m_PʍsB; }
            set { m_PʍsB = value; }
        }


        // PʍsB * A ({fBB()̊px\)
        public Matrix PʍsBA
        {
//            get { return m_PʍsB * m_Pʍs; }
                get
                {
                    Matrix m = m_PʍsB * m_Pʍs;
                    return m;
                }
        }


        // Bodys
        public Matrix BodysA
        {
            get
            {
                return m_Pʍs * Matrix.Translation( this.m_pos );
            }
        }

        // Bodys {fBB * {fBA
        public Matrix BodysBA
        {
            get
            {
//              return m_PʍsB * Matrix.Translation(this.m_pos);
                return m_PʍsB * m_Pʍs * Matrix.Translation(this.m_pos);
            }
        }


        // _W(㔼)
        public Vector3[] _WA
        {
            get
            {
                return this.BodyA._W;
            }
        }

        // _W()
        public Vector3[] _WB
        {
            get
            {
                return this.BodyB._W;
            }
        }

        public Mesh meshA
        {
            get { return this.BodyA.mesh; }
        }

        public Mesh meshB
        {
            get { return this.BodyB.mesh; }
        }



        // sb`(x̉])
        // d:]p(WA)
        public void RotateX_Pitch(float d)
        {
            Vector3 v = new Vector3(m_Pʍs.M11, m_Pʍs.M12, m_Pʍs.M13);    // ]̎\xNg
            Matrix m = Matrix.Identity;

            m.RotateAxis(v, d);         // Cӂ̎𒆐Sɍs]
            m_Pʍs *= m;            // Wϊ
        }


        // [(ỷ])
        public void RotateY_Yaw(float d)
        {
            Vector3 v = new Vector3(m_Pʍs.M21, m_Pʍs.M22, m_Pʍs.M23);    // ]̎\xNg
            Matrix m = Matrix.Identity;

            m.RotateAxis(v, d);         // Cӂ̎𒆐Sɍs]
            m_Pʍs *= m;            // Wϊ
        }


        // [(z̉])
        public void RotateZ_Roll(float d)
        {
            Vector3 v = new Vector3(m_Pʍs.M31, m_Pʍs.M32, m_Pʍs.M33);    // ]̎\xNg
            Matrix m = Matrix.Identity;

            m.RotateAxis(v, d);         // Cӂ̎𒆐Sɍs]
            m_Pʍs *= m;            // Wϊ
        }







        // ==========================================================
        // BodyB ------------------------------
        // [(ỷ])
        // d:]p(WA)
        public void RotateY_YawB(float d)
        {
            Vector3 v = new Vector3(m_PʍsB.M21, m_PʍsB.M22, m_PʍsB.M23);    // ]̎\xNg
            Matrix m = Matrix.Identity;

            m.RotateAxis(v, d);         // Cӂ̎𒆐Sɍs]
            m_PʍsB *= m;            // Wϊ
        }
        // ==========================================================







        //  ړ 
        public void i(float ړ)
        {
            m_pos.X += (m_Pʍs.M31 * ړ);
            m_pos.Y += (m_Pʍs.M32 * ړ);
            m_pos.Z += (m_Pʍs.M33 * ړ);
        }


        //  m_Pʍsm_posړ
        public void posΈړ( Vector3 ړ)
        {
            m_pos.X += (m_Pʍs.M11 * ړ.X);
            m_pos.Y += (m_Pʍs.M12 * ړ.X);
            m_pos.Z += (m_Pʍs.M13 * ړ.X);

            m_pos.X += (m_Pʍs.M21 * ړ.Y);
            m_pos.Y += (m_Pʍs.M22 * ړ.Y);
            m_pos.Z += (m_Pʍs.M23 * ړ.Y);

            m_pos.X += (m_Pʍs.M31 * ړ.Z);
            m_pos.Y += (m_Pʍs.M32 * ړ.Z);
            m_pos.Z += (m_Pʍs.M33 * ړ.Z);
        }



        //  w肳ꂽ΍Wւm_posړ
        public void posΈړ(Vector3 ړ)
        {
            m_pos.X += ړ.X;
            m_pos.Y += ړ.Y;
            m_pos.Z += ړ.Z;
        }





        /// <summary>
        /// Aj ({fBA 㔼 )
        /// Jns񂩂ڕWs֕ԂAm_PʍsɊi[
        /// </summary>
        /// <param name="Jns"></param>
        /// <param name="ڕWs"></param>
        /// <param name="ԋ"></param>
        public void Anime(Matrix Jns, Matrix ڕWs, float ԋ )
        {
            // ʐ`ԂgpāA2 ̃NH[^jIԂ
            Quaternion qs = Quaternion.Slerp(
                // ]s -> NH[^jI 쐬
                Quaternion.RotationMatrix( Jns ),
                Quaternion.RotationMatrix( ڕWs ),
                ԋ );

            // NH[^jI -> s 쐬
            this.m_Pʍs = Matrix.RotationQuaternion(qs);
        }





        /// <summary>
        /// Aj ({fBB  )
        /// Jns񂩂ڕWs֕ԂAm_PʍsɊi[
        /// </summary>
        /// <param name="Jns"></param>
        /// <param name="ڕWs"></param>
        /// <param name="ԋ"></param>
        public void AnimeB(Matrix Jns, Matrix ڕWs, float ԋ)
        {
            // ʐ`ԂgpāA2 ̃NH[^jIԂ
            Quaternion qs = Quaternion.Slerp(
                // ]s -> NH[^jI 쐬
                Quaternion.RotationMatrix(Jns),
                Quaternion.RotationMatrix(ڕWs),
                ԋ);

            // NH[^jI -> s 쐬
            this.m_PʍsB = Matrix.RotationQuaternion(qs);
        }










        // {^NbNɂeNX`p^[̐ؑ
        public void eNX`p^[ؑ(Device device)
        {
            this.m_eNX`p^[++;

            if ( this.m_eNX`p^[ <= this.m_eNX`p^[)
                this.m_eNX`p^[ = 0;

            this.switcheNX`p^[( device );
        }



        /// <summary>
        /// eNX`ݒ switch
        /// </summary>
        /// <param name="device"></param>
        public void switcheNX`p^[(Device device)
        {
            /*
            
            textureO = TextureLoader.FromFile(device, Utility.FindMediaFile("texture\\eNX`O.bmp"));
            ƎgpƁAtXN["Toggle reference (F3)"ŗOB
            */
            string path;

            switch (this.m_eNX`p^[)
            {
                case 0:
                    // ㉺
                    path = Utility.FindMediaFile("texture\\2O.bmp");
                    textureO = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\2.bmp");
                    texture = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\2E.bmp");
                    textureE = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\2.bmp");
                    texture = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);
                    break;

                case 1:
                    // 
                    path = Utility.FindMediaFile("texture\\ڑO.bmp");
                    textureO = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\ڌ.bmp");
                    texture = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\ډE.bmp");
                    textureE = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\ڍ.bmp");
                    texture = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);
                    break;

                case 2:
                    // UN 
                    path = Utility.FindMediaFile("texture\\UNO.bmp");
                    textureO = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\UN.bmp");
                    texture = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\UNE.bmp");
                    textureE = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\UN.bmp");
                    texture = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);
                    break;

                case 3:
                    // 
                    path = Utility.FindMediaFile("texture\\O.bmp");
                    textureO = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\.bmp");
                    texture = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\E.bmp");
                    textureE = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = Utility.FindMediaFile("texture\\.bmp");
                    texture = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);
                    break;

                case 4:
                    // xmlf`t@CŎw肳ꂽeNX`p^[
                    // 
                    textureO = null;
                    texture = null;
                    textureE = null;
                    texture = null;

                    // ݒ
                    path = m_textureOt@C;
                    // eNX`t@Cݒ`FbN
                    if( null != path && "" != path )
                        textureO = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = m_texturet@C;
                    if (null != path && "" != path)
                        texture = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = m_textureEt@C;
                    if (null != path && "" != path)
                        textureE = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    path = m_texturet@C;
                    if (null != path && "" != path)
                        texture = ResourceCache.GetGlobalInstance().CreateTextureFromFile(device, path);

                    break;
            }

            this.BodyA.textureO = this.textureO;
            this.BodyA.texture = this.texture;
            this.BodyA.textureE = this.textureE;
            this.BodyA.texture = this.texture;

            this.BodyB.textureO = this.textureO;
            this.BodyB.texture = this.texture;
            this.BodyB.textureE = this.textureE;
            this.BodyB.texture = this.texture;
        }






        public robotBodyBase()
        {
            // 
            // TODO: RXgN^ WbNɒǉĂB
            //
            BodyA = new robotBodyPartA();
            BodyB = new robotBodyPartB();
        }



        /// <summary>
        /// fB[vRs[
        /// </summary>
        public object Clone()
        {
            return new robotBodyBase(this);
        }

        
        
        /// <summary>
        /// fB[vRs[pRXgN^
        /// sc:Rs[
        /// </summary>
        public robotBodyBase(robotBodyBase sc)
        {
            this.Pʍs  = sc.Pʍs;
            this.PʍsB = sc.PʍsB;
        }



        public void CreateVB( Device device )
        {
            this.BodyA.CreateVB(device);   // {fB㕔
            this.BodyB.CreateVB(device);  // {fB

            this.switcheNX`p^[(device);
        }



        public void Draw( Device device, ModelViewerCamera camera, sbN ]Ώ )
        {
            this.BodyA.Draw(device, camera, ]Ώ, this.Pʍs,   this.pos );
            this.BodyB.Draw(device, camera, ]Ώ, this.PʍsBA, this.pos);
            // (BodyBBodyAɕtĂ)
        }



        // AAA -----------
        public void Draw̎( Device              device,
                                ModelViewerCamera   camera,
                                Vector3             \ʒu,
                                float               radY )  // ̎pYW]p
        {
            this.BodyA.Draw̎( device, camera, \ʒu, radY, this.Pʍs );     // {fBA()
            this.BodyB.Draw̎( device, camera, \ʒu, radY, this.PʍsBA );   // {fBB()
        }







        // obt@̊J
        public void Dispose()
        {
            this.BodyA.Dispose();
            this.BodyB.Dispose();
        }


    
    }
}
