using System;
using System.Windows.Forms;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

using Direct3D = Microsoft.DirectX.Direct3D;

namespace MyRobot
{
    /// <summary>
    /// {fB2 
    /// </summary>
    public class robotBodyPartB
    {
        Vector3 m_p0 = new Vector3();
        Vector3 m_p1 = new Vector3();

        Vector3[] m_p;      // lʑ̒_W

        Vector3[] m_p;  // lʑ̏㉺W

        VertexBuffer vertexBufferBody = null;    // lʑ(DrawPrimitives){fB eNX`\

        Texture m_textureO = null;
        Texture m_texture = null;

        Texture m_textureE = null;
        Texture m_texture = null;

        Mesh m_mesh = null; // {fB

        // ANZT ----------------------------------------------------------------------
        // eNX`
        public Texture textureO { set { m_textureO = value; } }
        public Texture texture { set { m_texture = value; } }
        public Texture textureE { set { m_textureE = value; } }
        public Texture texture { set { m_texture = value; } }

        // _W
        public Vector3[] _W
        {
            get { return this.m_p; }
        }

        public Mesh mesh
        {
            get { return m_mesh; }
        }


        public robotBodyPartB()
        {
            // 
            // TODO: RXgN^ WbNɒǉĂB
            //
            float t = (float)Math.Sqrt(2) / 2;  // lʑ̂̍

            m_p0 = new Vector3(0, -t, -1);
            m_p1 = new Vector3(0, -t,  1);

            m_p = new Vector3[2];
            m_p[0] = m_p0;
            m_p[1] = m_p1;
        }

        
        
        
        public void CreateVB( Device device )
        {
            // ӂ̒Q̐lʑ̂쐬 -> ㉺ɂQB
            // 4ʑ      4_ 4|S
            // 4ʑ2 6_ 8|S

            // lʑ̏㉺W
            m_p = new Vector3[4];
            m_p[0] = new Vector3( -0.5f, 0,  0.5f);
            m_p[1] = new Vector3(  0.5f, 0,  0.5f);
            m_p[2] = new Vector3(  0.5f, 0, -0.5f);
            m_p[3] = new Vector3( -0.5f, 0, -0.5f);

            int i = 0;
            Vector3 vn = new Vector3();

            // -------------------------------------------------------------
            /*
            Rp`̍ 
            Op`̂Pӂ̒Ƃ
            ́A * R / Q
            */
            /*
               v1 = p2 - p1                    P_Q_֌xNg (v1)
               v2 = pn - p1                    P_ŏI_֌xNg (v2)
               n = v1 cross v2                 v1  v2 ̊O (n)
            */
            // =================================================
            // =================================================
            vertexBufferBody = new VertexBuffer(typeof(CustomVertex.PositionNormalTextured), 24, device, Usage.WriteOnly, CustomVertex.PositionNormalTextured.Format, Pool.Default);
            VertexBuffer vb3 = (VertexBuffer)vertexBufferBody;
            CustomVertex.PositionNormalTextured[] verts3 = (CustomVertex.PositionNormalTextured[])vb3.Lock(0, 0);

            // -------------------------------------
            // WE
            // ==================
            // O
            vn = Vector3.Cross((m_p[2] - m_p[3]), (m_p0 - m_p[3]));
            verts3[i].Position = m_p[3];    verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[2];    verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p0;          verts3[i].Normal = vn; i++;

            // ==================
            // 
            vn = Vector3.Cross((m_p1 - m_p[0]), (m_p[1] - m_p[0]));
            verts3[i].Position = m_p[0];    verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p1;          verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[1];    verts3[i].Normal = vn; i++;

            // ==================
            // E(a)
            vn = Vector3.Cross((m_p[0] - m_p0), (m_p[3] - m_p0));
            verts3[i].Position = m_p0; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[0]; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[3]; verts3[i].Normal = vn; i++;

            // E(b)
            verts3[i].Position = m_p0; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p1; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[0]; verts3[i].Normal = vn; i++;

            // ==================
            // (a)
            vn = Vector3.Cross((m_p[2] - m_p1), (m_p[1] - m_p1));
            verts3[i].Position = m_p1; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[2]; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[1]; verts3[i].Normal = vn; i++;

            // (b)
            verts3[i].Position = m_p1; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p0; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[2]; verts3[i].Normal = vn; i++;

            // ==================
            // (a)
            vn = Vector3.Cross((m_p[2] - m_p[0]), (m_p[3] - m_p[0]));
            verts3[i].Position = m_p[0]; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[2]; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[3]; verts3[i].Normal = vn; i++;

            // (b)
            verts3[i].Position = m_p[0]; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[1]; verts3[i].Normal = vn; i++;
            verts3[i].Position = m_p[2]; verts3[i].Normal = vn; i++;

            // eNX`W
            float h1 = (float)( Math.Sqrt(3) / 2.0f );  // Op`
            float h2 = h1 / 2.0f;                       // Op` / 2
            // eNX`̐Op`gp -> Op`㉺2Ďgp

            i = 0;
            // ----------------
            // O
            verts3[i].Tu = 0.25f; verts3[i].Tv = h2; i++;
            verts3[i].Tu = 0.75f; verts3[i].Tv = h2; i++;
            verts3[i].Tu = 0.5f;  verts3[i].Tv = h1; i++;

            // ----------------
            // 
            verts3[i].Tu = 0.75f; verts3[i].Tv = h2; i++;
            verts3[i].Tu = 0.5f;  verts3[i].Tv = h1; i++;
            verts3[i].Tu = 0.25f; verts3[i].Tv = h2; i++;

            // ----------------
            // E(a)
            verts3[i].Tu = 1; verts3[i].Tv = 1; i++;
            verts3[i].Tu = 0.25f; verts3[i].Tv = 1 - h2; i++;
            verts3[i].Tu = 0.75f; verts3[i].Tv = 1 - h2; i++;

            // E(b)
            verts3[i].Tu = 1; verts3[i].Tv = 1; i++;
            verts3[i].Tu = 0; verts3[i].Tv = 1; i++;
            verts3[i].Tu = 0.25f; verts3[i].Tv = 1 - h2; i++;

            // ----------------
            // (a)
            verts3[i].Tu = 1; verts3[i].Tv = 1; i++;
            verts3[i].Tu = 0.25f; verts3[i].Tv = 1 - h2; i++;
            verts3[i].Tu = 0.75f; verts3[i].Tv = 1 - h2; i++;

            // (b)
            verts3[i].Tu = 1; verts3[i].Tv = 1; i++;
            verts3[i].Tu = 0; verts3[i].Tv = 1; i++;
            verts3[i].Tu = 0.25f; verts3[i].Tv = 1 - h2; i++;

            vb3.Unlock();

            // =================================================

            // --------------------------------------------------------------------------
            // Imesh--------------------------------------------------------
            // sbNp̃bV
            // \郁bV𓮓Iɐ
            int numTriangles = 8;

            m_mesh = new Mesh(numTriangles,     //  bV̖ʐ
                numTriangles * 3,               //  bV̒_
                MeshFlags.Managed,              //  bV̐IvV
                VertexFormats.PositionNormal,   //  _tH[}bgtO
                device);                        //  foCX

            //  _obt@̐ݒ
            CustomVertex.PositionNormal[] v = (CustomVertex.PositionNormal[])m_mesh.LockVertexBuffer(typeof(CustomVertex.PositionNormal), 0, numTriangles * 3);

            i = 0;
            // -------------------------------------
            // WE
            // ==================
            // O
            vn = Vector3.Cross((m_p[2] - m_p[3]), (m_p0 - m_p[3]));
            v[i].Position = m_p[3]; v[i].Normal = vn; i++;
            v[i].Position = m_p[2]; v[i].Normal = vn; i++;
            v[i].Position = m_p0; v[i].Normal = vn; i++;

            // ==================
            // 
            vn = Vector3.Cross((m_p1 - m_p[0]), (m_p[1] - m_p[0]));
            v[i].Position = m_p[0]; v[i].Normal = vn; i++;
            v[i].Position = m_p1; v[i].Normal = vn; i++;
            v[i].Position = m_p[1]; v[i].Normal = vn; i++;

            // ==================
            // E(a)
            vn = Vector3.Cross((m_p[0] - m_p0), (m_p[3] - m_p0));
            v[i].Position = m_p0; v[i].Normal = vn; i++;
            v[i].Position = m_p[0]; v[i].Normal = vn; i++;
            v[i].Position = m_p[3]; v[i].Normal = vn; i++;

            // E(b)
            v[i].Position = m_p0; v[i].Normal = vn; i++;
            v[i].Position = m_p1; v[i].Normal = vn; i++;
            v[i].Position = m_p[0]; v[i].Normal = vn; i++;

            // ==================
            // (a)
            vn = Vector3.Cross((m_p[2] - m_p1), (m_p[1] - m_p1));
            v[i].Position = m_p1; v[i].Normal = vn; i++;
            v[i].Position = m_p[2]; v[i].Normal = vn; i++;
            v[i].Position = m_p[1]; v[i].Normal = vn; i++;

            // (b)
            v[i].Position = m_p1; v[i].Normal = vn; i++;
            v[i].Position = m_p0; v[i].Normal = vn; i++;
            v[i].Position = m_p[2]; v[i].Normal = vn; i++;

            // ==================
            // (a)
            vn = Vector3.Cross((m_p[2] - m_p[0]), (m_p[3] - m_p[0]));
            v[i].Position = m_p[0]; v[i].Normal = vn; i++;
            v[i].Position = m_p[2]; v[i].Normal = vn; i++;
            v[i].Position = m_p[3]; v[i].Normal = vn; i++;

            // (b)
            v[i].Position = m_p[0]; v[i].Normal = vn; i++;
            v[i].Position = m_p[1]; v[i].Normal = vn; i++;
            v[i].Position = m_p[2]; v[i].Normal = vn; i++;

            m_mesh.UnlockVertexBuffer();

            // -------------------------------------------------------------
            //  CfbNXobt@̐ݒ
            ushort[] pIndex;

            pIndex = (ushort[])m_mesh.LockIndexBuffer(typeof(ushort), 0, numTriangles * 3);

            for (ushort iIndex = 0; iIndex < numTriangles * 3; iIndex++)
            {
                pIndex[iIndex] = iIndex;
            }
            m_mesh.UnlockIndexBuffer();
        }




        public void Draw(   Device device, ModelViewerCamera camera,
                            sbN  ]Ώ,
                            Matrix m,                   // BodyBPʍs(g) 
                            Vector3 pos )
        {
            // \ʒuApxݒ
            // ItZbgw肵čs쐬(ʒuw:x,y,z)
            m *= Matrix.Translation( pos );
            m *= camera.WorldMatrix;    // _̉]

            // [hsݒ
            device.Transform.World = m;

            // r[sݒ
            device.Transform.View = camera.ViewMatrix;

            // }eAݒ
            System.Drawing.Color col = System.Drawing.Color.White;

            // {fBsbNA]Ώۂ̎̓}eAԂ( {fBA() / {fBB() ꂼ )
            if(  sbN.{fBB == ]Ώ )
            {
                col = System.Drawing.Color.Red;
            }

            Direct3D.Material mtrl = new Direct3D.Material();
            mtrl.Diffuse = col;
            mtrl.Ambient = col;
            device.Material = mtrl;


            // -----------------------------------------------------------------

            // eNX` w
            device.TextureState[0].ColorOperation = TextureOperation.Modulate;
            device.TextureState[0].ColorArgument1 = TextureArgument.TextureColor;
            device.TextureState[0].ColorArgument2 = TextureArgument.Diffuse;
            device.TextureState[0].AlphaOperation = TextureOperation.Disable;

            device.RenderState.FillMode = FillMode.Solid;

            // lʑ(DrawPrimitives){fB
            device.SetStreamSource(0, vertexBufferBody, 0);
            device.VertexFormat = CustomVertex.PositionNormalTextured.Format;

            // {fB
            // lʑ̉
            // ================================================
            // ==================
            // O
            device.SetTexture(0, m_textureO);   // eNX`ݒ
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 0, 1);

            // ==================
            // 
            device.SetTexture(0, m_texture);   // eNX`ݒ
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 3, 1);

            // ==================
            // E
            device.SetTexture(0, m_textureE);   // eNX`ݒ
            // E(a)
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 6, 1);
            // E(b)
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 9, 1);

            // ==================
            // 
            device.SetTexture(0, m_texture);   // eNX`ݒ
            // (a)
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 12, 1);
            // (b)
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 15, 1);

            // --------------------------------------------------------------
            device.SetTexture(0, null);// eNX`
            // 
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 18, 1);
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 21, 1);

        }



        // AAA -----------
        public void Draw̎(Device device,
                        ModelViewerCamera camera,
                        Vector3 \ʒu,
                        float radY,   // ̎pYW]p
                        Matrix m)     // ]s(BodyPʍs) 
        {
            // \ʒuApxݒ
            // ItZbgw肵čs쐬(ʒuw:x,y,z)
            // _̉]
            m *= camera.ViewMatrix;

            // ̎pYW]
            Matrix mY = Matrix.Identity;
            mY.RotateY(radY);
            m *= mY;

            // \ʒu̎w
            m.M41 = \ʒu.X; // x
            m.M42 = \ʒu.Y; // y
            m.M43 = \ʒu.Z; // z

            // r[sݒ
            device.Transform.View = Matrix.Identity;

            // [hsݒ
            device.Transform.World = m;

            // }eAݒ
            System.Drawing.Color col = System.Drawing.Color.White;

            Direct3D.Material mtrl = new Direct3D.Material();
            mtrl.Diffuse = col;
            mtrl.Ambient = col;
            device.Material = mtrl;

            // -----------------------------------------------------------------
            // eNX` w
            device.TextureState[0].ColorOperation = TextureOperation.Modulate;
            device.TextureState[0].ColorArgument1 = TextureArgument.TextureColor;
            device.TextureState[0].ColorArgument2 = TextureArgument.Diffuse;
            device.TextureState[0].AlphaOperation = TextureOperation.Disable;

            device.RenderState.FillMode = FillMode.Solid;

            // lʑ(DrawPrimitives){fB
            device.SetStreamSource(0, vertexBufferBody, 0);
            device.VertexFormat = CustomVertex.PositionNormalTextured.Format;

            // ----------------------------------------------------------------
            // {fB
            // lʑ̉
            // ================================================
            // ==================
            // O
            device.SetTexture(0, m_textureO);   // eNX`ݒ
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 0, 1);

            // ==================
            // 
            device.SetTexture(0, m_texture);   // eNX`ݒ
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 3, 1);

            // ==================
            // E
            device.SetTexture(0, m_textureE);   // eNX`ݒ
            // E(a)
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 6, 1);
            // E(b)
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 9, 1);

            // ==================
            // 
            device.SetTexture(0, m_texture);   // eNX`ݒ
            // (a)
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 12, 1);
            // (b)
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 15, 1);

            // --------------------------------------------------------------
            device.SetTexture(0, null);// eNX`
            // 
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 18, 1);
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 21, 1);
        }


        // obt@̊J
        public void Dispose()
        {
            if (null != this.vertexBufferBody)
            {
                this.vertexBufferBody.Dispose();
            }

            if (null != this.m_mesh)
            {
                this.m_mesh.Dispose();
            }
        }


    
    }
}
