using System;
using System.Windows.Forms;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

using Direct3D = Microsoft.DirectX.Direct3D;


namespace robotSample
{
    
    /// <summary>
    /// 
    /// </summary>
    public class robotObject
    {

        Vector3 p0 = new Vector3();
        Vector3 p1 = new Vector3();
        Vector3 p2 = new Vector3();
        Vector3 p3 = new Vector3();

        private Mesh mesh = null;	// lʑ(IbV){fB
        private Mesh meshQ  = null;	// \KChp
        private Mesh meshr = null;	// r()

        VertexBuffer vertexBufferAAA = null;    // eXgp
        VertexBuffer vertexBufferBBB = null;    // lʑ(DrawPrimitives){fB
        VertexBuffer vertexBufferCCC = null;    // lʑ(DrawPrimitives){fB eNX`\

        Texture textureAAA = null;
        Texture textureC1 = null;
        Texture textureC2 = null;

        Texture textureO = null;
        Texture texture = null;

        Texture textureE = null;
        Texture texture = null;


        int sw = 9;

        public robotObject()
        {
            // 
            // TODO: RXgN^ WbNɒǉĂB
            //
        }

        
        
        
        public void CreateVB(Device device)
        {
            // ӂ̒Q̐lʑ̂쐬
//          float t = 0.7071072f;
            float t = (float)Math.Sqrt(2) / 2;

            p0 = new Vector3( -1,  t,  0);
            p1 = new Vector3(  1,  t,  0);

            p2 = new Vector3(  0, -t, -1);
            p3 = new Vector3(  0, -t,  1);

            {
                float f = 2.0f;
                meshQ = Mesh.Box(device, f, f, f);                // device,,,[
                meshQ = Mesh.Sphere(device, p0.Length(), 8, 8);   // 

//                meshQ = Mesh.Cylinder(device, 1, 0, ((float)Math.Sqrt(2)), 3, 1);   // ~
                /*
                 * ~
                device  Microsoft.DirectX.Direct3D.DeviceB쐬ꂽ~̃bVɊ֘AtĂfoCX\ Device IuWFNgB 
                radius1  System.SingleBz ̖̑̕ʂ̔aBl 0.0f ȏłȂ΂Ȃ܂B 
                radius2  System.SingleBz ̖̐̑ʂ̔aBl 0.0f ȏłȂ΂Ȃ܂B 
                length  System.SingleBz ̉~̒B 
                slices  System.Int32B厲]ƂXCX̐B 
                stacks  System.Int32B厲ɉX^bN̐B 
                 */

            }

            this.meshr = Mesh.Sphere(device, 1, 32, 32);   // 

            // --------------------------------------------------------------------------
            // \郁bV𓮓Iɐ
            // PʍsɊÂOp
            int numTriangles = 4;

            mesh = new Mesh(numTriangles,   //  bV̖ʐ
                numTriangles * 3,           //  bV̒_
                MeshFlags.Managed,          //  bV̐IvV
                MyVertex.Format,            //  _tH[}bgtO
                device);                    //  foCX


            //	_obt@̐ݒ
            MyVertex[] v = (MyVertex[])mesh.LockVertexBuffer(typeof(MyVertex), 0, numTriangles * 3);

            int i = 0;

            // O(-z)
            v[i].p = p0; v[i].color = System.Drawing.Color.Red.ToArgb(); i++;
            v[i].p = p1; v[i].color = System.Drawing.Color.White.ToArgb(); i++;
            v[i].p = p2; v[i].color = System.Drawing.Color.White.ToArgb(); i++;

            // (z)
            v[i].p = p0; v[i].color = System.Drawing.Color.Red.ToArgb(); i++;
            v[i].p = p3; v[i].color = System.Drawing.Color.Gainsboro.ToArgb(); i++;
            v[i].p = p1; v[i].color = System.Drawing.Color.Gainsboro.ToArgb(); i++;

            // E(x)
            v[i].p = p1; v[i].color = System.Drawing.Color.Red.ToArgb(); i++;
            v[i].p = p3; v[i].color = System.Drawing.Color.Gray.ToArgb(); i++;
            v[i].p = p2; v[i].color = System.Drawing.Color.Gray.ToArgb(); i++;

            // (-x)
            v[i].p = p0; v[i].color = System.Drawing.Color.Yellow.ToArgb(); i++;
            v[i].p = p2; v[i].color = System.Drawing.Color.Gold.ToArgb(); i++;
            v[i].p = p3; v[i].color = System.Drawing.Color.Gold.ToArgb(); i++;


            // ------------------------------------
            // @
            i = 0;
            // O(-z)
            v[i].n = Vector3.Cross((p1 - p0), (p2 - p0)); i++;
            v[i].n = Vector3.Cross((p1 - p0), (p2 - p0)); i++;
            v[i].n = Vector3.Cross((p1 - p0), (p2 - p0)); i++;

            // (z)
            v[i].n = Vector3.Cross((p3 - p0), (p1 - p0)); i++;
            v[i].n = Vector3.Cross((p3 - p0), (p1 - p0)); i++;
            v[i].n = Vector3.Cross((p3 - p0), (p1 - p0)); i++;

            // E(x)
            v[i].n = Vector3.Cross((p3 - p1), (p2 - p1)); i++;
            v[i].n = Vector3.Cross((p3 - p1), (p2 - p1)); i++;
            v[i].n = Vector3.Cross((p3 - p1), (p2 - p1)); i++;

            // (-x)
            v[i].n = Vector3.Cross((p2 - p0), (p3 - p0)); i++;
            v[i].n = Vector3.Cross((p2 - p0), (p3 - p0)); i++;
            v[i].n = Vector3.Cross((p2 - p0), (p3 - p0)); i++;
            // ------------------------------------
            // eNX`W
            i = 0;

            // eNX`̐Op`gp
            // O(-z)
            v[i].tu = 0.0f; v[i].tv = 1.0f; i++;
            v[i].tu = 0.5f; v[i].tv = 1.0f-((float)Math.Sqrt(3) / 2.0f); i++;
            v[i].tu = 1.0f; v[i].tv = 1.0f; i++;

            // (z)
            v[i].tu = 0.0f; v[i].tv = 1.0f; i++;
            v[i].tu = 0.5f; v[i].tv = 1.0f - ((float)Math.Sqrt(3) / 2.0f); i++;
            v[i].tu = 1.0f; v[i].tv = 1.0f; i++;

            // E(x)
            v[i].tu = 0.0f; v[i].tv = 1.0f; i++;
            v[i].tu = 0.5f; v[i].tv = 1.0f - ((float)Math.Sqrt(3) / 2.0f); i++;
            v[i].tu = 1.0f; v[i].tv = 1.0f; i++;

            // (-x)
            v[i].tu = 0.0f; v[i].tv = 1.0f; i++;
            v[i].tu = 0.5f; v[i].tv = 1.0f - ((float)Math.Sqrt(3) / 2.0f); i++;
            v[i].tu = 1.0f; v[i].tv = 1.0f; i++;

            mesh.UnlockVertexBuffer();

            // -------------------------------------------------------------
            /*
            Rp`̍ 
            Op`̂Pӂ̒Ƃ
            ́A * R / Q
            */
////////
            /*
               v1 = p2 - p1                    P_Q_֌xNg (v1)
               v2 = pn - p1                    P_ŏI_֌xNg (v2)
               n = v1 cross v2                 v1  v2 ̊O (n)
             */ 
///////

            //	CfbNXobt@̐ݒ
            ushort[] pIndex;

            pIndex = (ushort[])mesh.LockIndexBuffer(typeof(ushort), 0, numTriangles * 3);

            for (ushort iIndex = 0; iIndex < numTriangles * 3; iIndex++)
            {
                pIndex[iIndex] = iIndex;
            }
            mesh.UnlockIndexBuffer();


            // ---------------------------------
            if (sw == 0)
            {
                vertexBufferAAA = new VertexBuffer(typeof(CustomVertex.PositionNormal), 100, device, Usage.WriteOnly, CustomVertex.PositionNormal.Format, Pool.Default);
                VertexBuffer vb = (VertexBuffer)vertexBufferAAA;
                CustomVertex.PositionNormal[] verts = (CustomVertex.PositionNormal[])vb.Lock(0, 0);
                for (int ii = 0; ii < 50; ii++)
                {
                    // Fill up our structs
                    float theta = (float)(2 * Math.PI * ii) / 49;
                    verts[2 * ii].Position = new Vector3((float)Math.Sin(theta), -1, (float)Math.Cos(theta));
                    verts[2 * ii].Normal = new Vector3((float)Math.Sin(theta), 0, (float)Math.Cos(theta));

                    verts[2 * ii + 1].Position = new Vector3((float)Math.Sin(theta), 1, (float)Math.Cos(theta));
                    verts[2 * ii + 1].Normal = new Vector3((float)Math.Sin(theta), 0, (float)Math.Cos(theta));
                }
                vb.Unlock();
            }
            else if(sw == 1)
            {
                vertexBufferAAA = new VertexBuffer(typeof(CustomVertex.PositionNormalColored), 3, device, Usage.WriteOnly, CustomVertex.PositionNormalColored.Format, Pool.Default);
                VertexBuffer vb = (VertexBuffer)vertexBufferAAA;
                CustomVertex.PositionNormalColored[] verts = (CustomVertex.PositionNormalColored[])vb.Lock(0, 0);

                //  
                verts[0].Position = new Vector3(0, 0, 0);
                verts[0].Normal =   new Vector3(0, 1, 0);
                verts[0].Color = System.Drawing.Color.Red.ToArgb();

                verts[1].Position = new Vector3(0, 0, 1);
                verts[1].Normal =   new Vector3(0, 1, 1);
                verts[1].Color = System.Drawing.Color.Green.ToArgb();

                verts[2].Position = new Vector3(1, 0, 0);
                verts[2].Normal =   new Vector3(1, 1, 0);
                verts[2].Color = System.Drawing.Color.Blue.ToArgb();
                
                vb.Unlock();
            }
            else if (sw == 2)
            {
                // eNX`
                vertexBufferAAA = new VertexBuffer(typeof(CustomVertex.PositionNormalTextured), 3, device, Usage.WriteOnly, CustomVertex.PositionNormalTextured.Format, Pool.Default);
                VertexBuffer vb = (VertexBuffer)vertexBufferAAA;
                CustomVertex.PositionNormalTextured[] verts = (CustomVertex.PositionNormalTextured[])vb.Lock(0, 0);

                /*
                 Tu,TveNX`W
                 (0.0, 0.0) E(1.0, 1.0)
                 */ 

                //  
                verts[0].Position = new Vector3(0, 0, 0);
                verts[0].Normal = new Vector3(0, 1, 0);
                verts[0].Tu = 0.0f;
                verts[0].Tv = 0.0f;

                verts[1].Position = new Vector3(0, 0, 1);
                verts[1].Normal = new Vector3(0, 1, 1);
                verts[1].Tu = 0.0f;
                verts[1].Tv = 1.0f;

                verts[2].Position = new Vector3(1, 0, 0);
                verts[2].Normal = new Vector3(1, 1, 0);
                verts[2].Tu = 1.0f;
                verts[2].Tv = 0.0f;

                vb.Unlock();
            }



            // =================================================
            vertexBufferBBB = new VertexBuffer(typeof(CustomVertex.PositionNormalColored), 12, device, Usage.WriteOnly, CustomVertex.PositionNormalColored.Format, Pool.Default);
            VertexBuffer vb2 = (VertexBuffer)vertexBufferBBB;
            CustomVertex.PositionNormalColored[] verts2 = (CustomVertex.PositionNormalColored[])vb2.Lock(0, 0);


            i = 0;
            // O(-z)
            verts2[i].Position = p0; verts2[i].Normal = Vector3.Cross((p1 - p0), (p2 - p0)); i++;
            verts2[i].Position = p1; verts2[i].Normal = Vector3.Cross((p1 - p0), (p2 - p0)); i++;
            verts2[i].Position = p2; verts2[i].Normal = Vector3.Cross((p1 - p0), (p2 - p0)); i++;

            // (z)
            verts2[i].Position = p0; verts2[i].Normal = Vector3.Cross((p3 - p0), (p1 - p0)); i++;
            verts2[i].Position = p3; verts2[i].Normal = Vector3.Cross((p3 - p0), (p1 - p0)); i++;
            verts2[i].Position = p1; verts2[i].Normal = Vector3.Cross((p3 - p0), (p1 - p0)); i++;

            // E(x)
            verts2[i].Position = p1; verts2[i].Normal = Vector3.Cross((p3 - p1), (p2 - p1)); i++;
            verts2[i].Position = p3; verts2[i].Normal = Vector3.Cross((p3 - p1), (p2 - p1)); i++;
            verts2[i].Position = p2; verts2[i].Normal = Vector3.Cross((p3 - p1), (p2 - p1)); i++;

            // (-x)
            verts2[i].Position = p0; verts2[i].Normal = Vector3.Cross((p2 - p0), (p3 - p0)); i++;
            verts2[i].Position = p2; verts2[i].Normal = Vector3.Cross((p2 - p0), (p3 - p0)); i++;
            verts2[i].Position = p3; verts2[i].Normal = Vector3.Cross((p2 - p0), (p3 - p0)); i++;


            // J[ ----------------------
            i = 0;

            // O(-z)
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//0
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//1
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//2

            // (z)
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//3
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//4
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//5

            // E(x)
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//6
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//7
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//8

            // (-x)
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//9
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//10
            verts2[i].Color = System.Drawing.Color.Red.ToArgb(); i++;//11

            vb2.Unlock();



            // =================================================
            // =================================================
            vertexBufferCCC = new VertexBuffer(typeof(CustomVertex.PositionNormalTextured), 12, device, Usage.WriteOnly, CustomVertex.PositionNormalTextured.Format, Pool.Default);
            VertexBuffer vb3 = (VertexBuffer)vertexBufferCCC;
            CustomVertex.PositionNormalTextured[] verts3 = (CustomVertex.PositionNormalTextured[])vb3.Lock(0, 0);

            i = 0;
            // O(-z)
            verts3[i].Position = p0; verts3[i].Normal = Vector3.Cross((p1 - p0), (p2 - p0)); i++;
            verts3[i].Position = p1; verts3[i].Normal = Vector3.Cross((p1 - p0), (p2 - p0)); i++;
            verts3[i].Position = p2; verts3[i].Normal = Vector3.Cross((p1 - p0), (p2 - p0)); i++;

            // (z)
            verts3[i].Position = p0; verts3[i].Normal = Vector3.Cross((p3 - p0), (p1 - p0)); i++;
            verts3[i].Position = p3; verts3[i].Normal = Vector3.Cross((p3 - p0), (p1 - p0)); i++;
            verts3[i].Position = p1; verts3[i].Normal = Vector3.Cross((p3 - p0), (p1 - p0)); i++;

            // E(-x)
            verts3[i].Position = p0; verts3[i].Normal = Vector3.Cross((p2 - p0), (p3 - p0)); i++;
            verts3[i].Position = p2; verts3[i].Normal = Vector3.Cross((p2 - p0), (p3 - p0)); i++;
            verts3[i].Position = p3; verts3[i].Normal = Vector3.Cross((p2 - p0), (p3 - p0)); i++;

            // (x)
            verts3[i].Position = p1; verts3[i].Normal = Vector3.Cross((p3 - p1), (p2 - p1)); i++;
            verts3[i].Position = p3; verts3[i].Normal = Vector3.Cross((p3 - p1), (p2 - p1)); i++;
            verts3[i].Position = p2; verts3[i].Normal = Vector3.Cross((p3 - p1), (p2 - p1)); i++;


            // eNX`W
            i = 0;
            // eNX`̐Op`gp
            // O(-z)
            verts3[i].Tu = 0.0f; verts3[i].Tv = 0.0f; i++;
            verts3[i].Tu = 1.0f; verts3[i].Tv = 0.0f; i++;
            verts3[i].Tu = 0.5f; verts3[i].Tv = ((float)Math.Sqrt(3) / 2.0f); i++;

            // (z)
            /*
            verts3[i].Tu = 0.0f; verts3[i].Tv = 1.0f; i++;
            verts3[i].Tu = 0.5f; verts3[i].Tv = 1.0f - ((float)Math.Sqrt(3) / 2.0f); i++;
            verts3[i].Tu = 1.0f; verts3[i].Tv = 1.0f; i++;
            */
            verts3[i].Tu = 1.0f; verts3[i].Tv = 0.0f; i++;
            verts3[i].Tu = 0.5f; verts3[i].Tv = ((float)Math.Sqrt(3) / 2.0f); i++;
            verts3[i].Tu = 0.0f; verts3[i].Tv = 0.0f; i++;

            // E(x)
            verts3[i].Tu = 0.5f; verts3[i].Tv = 1.0f - ((float)Math.Sqrt(3) / 2.0f); i++;
            verts3[i].Tu = 1.0f; verts3[i].Tv = 1.0f; i++;
            verts3[i].Tu = 0.0f; verts3[i].Tv = 1.0f; i++;

            // (-x)
            verts3[i].Tu = 0.5f; verts3[i].Tv = 1.0f - ((float)Math.Sqrt(3) / 2.0f); i++;
            verts3[i].Tu = 1.0f; verts3[i].Tv = 1.0f; i++;
            verts3[i].Tu = 0.0f; verts3[i].Tv = 1.0f; i++;


            vb3.Unlock();

            // =================================================
            // =================================================



            // Now create our texture
//          textureAAA = TextureLoader.FromFile(device, Application.StartupPath + @"\..\..\banana.bmp");
//          textureAAA = TextureLoader.FromFile(device, Application.StartupPath + @"\..\..\eNX`2.bmp");
            textureAAA = TextureLoader.FromFile(device, Application.StartupPath + @"\..\..\~bv}bveNX`.bmp");

            textureC1 = TextureLoader.FromFile(device, Application.StartupPath + @"\..\..\~bv}bveNX`.bmp");
            textureC2 = TextureLoader.FromFile(device, Application.StartupPath + @"\..\..\banana.bmp");

            textureO = TextureLoader.FromFile(device, Application.StartupPath + @"\..\..\eNX`O.bmp");
            texture = TextureLoader.FromFile(device, Application.StartupPath + @"\..\..\eNX`.bmp");

            textureE = TextureLoader.FromFile(device, Application.StartupPath + @"\..\..\eNX`E.bmp");
            texture = TextureLoader.FromFile(device, Application.StartupPath + @"\..\..\eNX`.bmp");

        }


        public void Draw( Device device, ModelViewerCamera camera )
        {
            System.Drawing.Color col = System.Drawing.Color.White;

            Direct3D.Material mtrl = new Direct3D.Material();
            mtrl.Diffuse = col;
            mtrl.Ambient = col;
            device.Material = mtrl;

            device.SetTexture(0, null);// eNX`

            // -----------------------------------------------------------------
            device.RenderState.Lighting = true;

            // bV\
            device.RenderState.FillMode = FillMode.WireFrame;
//          meshQ.DrawSubset(0);

            device.RenderState.Lighting = true;

            // eNX` w
            device.SetTexture(0, textureAAA);
            device.TextureState[0].ColorOperation = TextureOperation.Modulate;
            device.TextureState[0].ColorArgument1 = TextureArgument.TextureColor;
            device.TextureState[0].ColorArgument2 = TextureArgument.Diffuse;
            device.TextureState[0].AlphaOperation = TextureOperation.Disable;

            device.RenderState.FillMode = FillMode.Solid;
//          mesh.DrawSubset(0);


/*
            // ----------------------
            device.RenderState.Lighting = true;
            device.RenderState.FillMode = FillMode.WireFrame;

            // ]s쐬
            Matrix m;

            // -------------------------------------
            m = Matrix.Identity;
            // ItZbgw肵čs쐬
            m *= Matrix.Translation( this.p0 );
            m *= camera.WorldMatrix;	// _̉]
            // [hsݒ
            device.Transform.World = m;
            // r[sݒ
            device.Transform.View = camera.ViewMatrix;
            this.meshr.DrawSubset(0);

            // -------------------------------------
            m = Matrix.Identity;
            // ItZbgw肵čs쐬
            m *= Matrix.Translation(this.p1);
            m *= camera.WorldMatrix;	// _̉]
            // [hsݒ
            device.Transform.World = m;
            // r[sݒ
            device.Transform.View = camera.ViewMatrix;
            this.meshr.DrawSubset(0);
            // -------------------------------------
            m = Matrix.Identity;
            // ItZbgw肵čs쐬
            m *= Matrix.Translation(this.p2);
            m *= camera.WorldMatrix;	// _̉]
            // [hsݒ
            device.Transform.World = m;
            // r[sݒ
            device.Transform.View = camera.ViewMatrix;
            this.meshr.DrawSubset(0);
            // -------------------------------------
            m = Matrix.Identity;
            // ItZbgw肵čs쐬
            m *= Matrix.Translation(this.p3);
            m *= camera.WorldMatrix;	// _̉]
            // [hsݒ
            device.Transform.World = m;
            // r[sݒ
            device.Transform.View = camera.ViewMatrix;
            this.meshr.DrawSubset(0);
*/

            // -------------------------------------
            device.SetStreamSource(0, vertexBufferAAA, 0);
            if (sw == 0)
            {
                device.VertexFormat = CustomVertex.PositionNormal.Format;
                device.DrawPrimitives(PrimitiveType.TriangleStrip, 0, (4 * 25) - 2);
            }
            else if(sw == 1)
            {
                device.VertexFormat = CustomVertex.PositionNormalColored.Format;
                device.DrawPrimitives(PrimitiveType.TriangleStrip, 0, 1);
            }
            else if (sw == 2)
            {
                // eNX`
                device.SetTexture(0, textureAAA);
                device.TextureState[0].ColorOperation = TextureOperation.Modulate;
                device.TextureState[0].ColorArgument1 = TextureArgument.TextureColor;
                device.TextureState[0].ColorArgument2 = TextureArgument.Diffuse;
                device.TextureState[0].AlphaOperation = TextureOperation.Disable;

                device.VertexFormat = CustomVertex.PositionNormalTextured.Format;
                device.DrawPrimitives(PrimitiveType.TriangleStrip, 0, 1);

            }

            // -------------------------------------
            /*
                         // lʑ(DrawPrimitives){fB
                        device.SetStreamSource(0, vertexBufferBBB, 0);
                        device.VertexFormat = CustomVertex.PositionNormalColored.Format;
                        device.DrawPrimitives(PrimitiveType.TriangleStrip, 0, 1 );
                        device.DrawPrimitives(PrimitiveType.TriangleStrip, 3, 1);
                        device.DrawPrimitives(PrimitiveType.TriangleStrip, 6, 1);
                        device.DrawPrimitives(PrimitiveType.TriangleStrip, 9, 1);
             */

            // lʑ(DrawPrimitives){fB
            device.SetStreamSource(0, vertexBufferCCC, 0);
            device.VertexFormat = CustomVertex.PositionNormalTextured.Format;

            // O(-z)
            device.SetTexture(0, textureO);   // eNX`ݒ
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 0, 1);

            // (z)
            device.SetTexture(0, texture);   // eNX`ݒ
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 3, 1);

            // E(x)
            device.SetTexture(0, textureE);   // eNX`ݒ
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 6, 1);

            // (-x)
            device.SetTexture(0, texture);   // eNX`ݒ
            device.DrawPrimitives(PrimitiveType.TriangleStrip, 9, 1);

        }


        // obt@̊J
        public void Dispose()
        {
            if (null != this.mesh)
            {
                this.mesh.Dispose();
            }
            if (null != this.meshQ)
            {
                this.meshQ.Dispose();
            }
            if (null != this.meshr)
            {
                this.meshr.Dispose();
            }
            if (null != this.vertexBufferAAA)
            {
                this.vertexBufferAAA.Dispose();
            }
            if (null != this.vertexBufferBBB)
            {
                this.vertexBufferBBB.Dispose();
            }
            if (null != this.vertexBufferCCC)
            {
                this.vertexBufferCCC.Dispose();
            }

        }

// http://msdn.microsoft.com/library/ja/default.asp?url=/library/ja/DirectX9_m/directx/direct3d/tasks/createameshobject.asp

        //	IbV̂߂̒_tH[}bg
        struct MyVertex
        {
            public Vector3  p;      // _ʒu
            public Vector3  n;      // @
            public int      color;	// _J[
            public float    tu,tv;	// eNX`W

            //	_tH[}bgtO
//          public static readonly VertexFormats Format = VertexFormats.Position | VertexFormats.Diffuse;
//          public static readonly VertexFormats Format = VertexFormats.Position | VertexFormats.Diffuse | VertexFormats.Normal;
            public static readonly VertexFormats Format = VertexFormats.Position | VertexFormats.Diffuse | VertexFormats.Normal | VertexFormats.Texture1;

            /*
            LightWave 3D(DirectX)̃|ŚAv肪ƒ`Ă܂B @̓̕|S̉̖ʂ肵܂B 

            |S̖@xNǵA|S\PԖڂ̐ƍŌ̐̊OςvZ邱Ƃł܂B 

               v1 = p2 - p1                    P_Q_֌xNg (v1)
               v2 = pn - p1                    P_ŏI_֌xNg (v2)
               n = v1 cross v2                 v1  v2 ̊O (n)

            public static Vector3 Cross(
                Vector3 pOut,
                Vector3 pV1,
                Vector3 pV2
            );
             */
        };

    
    }
}
