using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

using DefineRobot;

namespace MyRobot
{


    public class robotUnit
    {
        public robotBodyBase    Body;
        public robotArm[]       Arm;


        /// <summary>
        /// fB[vRs[
        /// Aj[VpɃ{fB/A[-p[c̒Pʍŝ݂fB[vRs[
        /// </summary>
        public object Clone()
        {
            return new robotUnit(this);
        }

		/// <summary>
		/// fB[vRs[pRXgN^
		/// sc:Rs[
		/// </summary>
        public robotUnit(robotUnit sc)
		{
            this.Body = (robotBodyBase)sc.Body.Clone();

            this.Arm = new robotArm[4];
            for (int i = 0; i < this.Arm.Length; i++)
            {
                this.Arm[i] = null;
                this.Arm[i] = (robotArm)sc.Arm[i].Clone();
            }
        }



        public robotUnit()
		{
            Body = new robotBodyBase();

            this.Arm = new robotArm[4];
            for (int i = 0; i < this.Arm.Length; i++)
            {
                this.Arm[i] = null;
                this.Arm[i] = new robotArm();
            }

            // ř
//          this.Arm[3].Parts[0].RotateY_Yaw((float)(180.0f * Math.PI / 180));
            this.Arm[3].Parts[0].RotateY_Yaw((float)Math.PI);
        }


        
        // f`t@CǍ
        public void CreateVB(Device device, `Unit `Unit)
        {
            this.Body.CreateVB(device);
            
            for (int i = 0; i < this.Arm.Length; i++)
            {
                this.Arm[i].CreateVB( device, `Unit.`Arm[i] );
            }
        }



        // f`t@CeNX`ݒ
        public void f`eNX`ݒ(`Unit `Unit)
        {
            // f`t@CŎw肳ꂽeNX`ݒ
            this.Body.textureOt@C = null;
            this.Body.texturet@C = null;
            this.Body.textureEt@C = null;
            this.Body.texturet@C = null;

            if (null != `Unit.`Body.textureOt@C)
            {
                this.Body.eNX`p^[ = 5; // eNX`p^[ l:4 fǍ:5
                this.Body.m_eNX`p^[ = 4;
                this.Body.textureOt@C = `Unit.`Body.textureOt@C;
            }

            if (null != `Unit.`Body.texturet@C)
            {
                this.Body.eNX`p^[ = 5; // eNX`p^[ l:4 fǍ:5
                this.Body.m_eNX`p^[ = 4;
                this.Body.texturet@C = `Unit.`Body.texturet@C;
            }

            if (null != `Unit.`Body.textureEt@C)
            {
                this.Body.eNX`p^[ = 5; // eNX`p^[ l:4 fǍ:5
                this.Body.m_eNX`p^[ = 4;
                this.Body.textureEt@C = `Unit.`Body.textureEt@C;
            }

            if (null != `Unit.`Body.texturet@C)
            {
                this.Body.eNX`p^[ = 5; // eNX`p^[ l:4 fǍ:5
                this.Body.m_eNX`p^[ = 4;
                this.Body.texturet@C = `Unit.`Body.texturet@C;
            }
        }




        /// <summary>
        /// obt@J
        /// </summary>
        public void Dispose()
        {
            this.Body.Dispose();

            for (int i = 0; i < this.Arm.Length; i++)
            {
                this.Arm[i].Dispose();
            }
        }



        /// <summary>
        /// {fBƘr̕`
        /// </summary>
        /// <param name="device"></param>
        /// <param name="camera"></param>
        /// <param name="iPickArm"></param>
        /// <param name="iPickPart"></param>
        public void Draw(   Device device, ModelViewerCamera camera,
                            sbN  ]Ώ,
                            int iPickArm,   // }EX sbN A[
                            int iPickPart)  // }EX sbN p[c
        {
            try
            {
                // {fB\
                this.Body.Draw(device, camera, ]Ώ);

                // r\
                int pick = -1;   // sbNΏ Fςĕ\
                if (0 == iPickArm) pick = iPickPart;
                this.Arm[0].Draw(device, camera, Body.pos, Body._WA[0], Body.Pʍs,  pick);

                pick = -1;
                if (1 == iPickArm) pick = iPickPart;
                this.Arm[1].Draw(device, camera, Body.pos, Body._WA[1], Body.Pʍs, pick);

                pick = -1;
                if (2 == iPickArm) pick = iPickPart;
                this.Arm[2].Draw(device, camera, Body.pos, Body._WB[0], Body.PʍsBA, pick);

                pick = -1;
                if (3 == iPickArm) pick = iPickPart;
                this.Arm[3].Draw(device, camera, Body.pos, Body._WB[1], Body.PʍsBA, pick);
            }
            catch (Exception e)
            {
                throw (e);
            }
        } // Draw end




        // ---------------------------------------------------
        // AAA
        public void Draw̎( Device device, ModelViewerCamera camera,
                   			    Vector3 \ʒu,
                                float   radY )  // ̎pYW]p
        {
            try
            {
                // {fB\
                this.Body.Draw̎(device, camera, \ʒu, radY);

                // r\
                this.Arm[0].Draw̎(device, camera, Body.pos, Body._WA[0], Body.Pʍs,   \ʒu, radY );
                this.Arm[1].Draw̎(device, camera, Body.pos, Body._WA[1], Body.Pʍs,   \ʒu, radY );
                this.Arm[2].Draw̎(device, camera, Body.pos, Body._WB[0], Body.PʍsBA, \ʒu, radY );
                this.Arm[3].Draw̎(device, camera, Body.pos, Body._WB[1], Body.PʍsBA, \ʒu, radY );
            }
            catch (Exception e)
            {
                throw (e);
            }
        } // Draw end





        /// <summary>
        /// Aj
        /// {fBƃA[-p[c̒PʍsڕW|[Y֕
        /// </summary>
        /// <param name="ڕWRobotUnit"></param>
        /// <param name="ԋ"></param>
        public void Anime(robotUnit RobotUnitAnimeJn, robotUnit RobotUnitAnimeڕW, float ԋ)
        {
            // {fBA (㔼)
            this.Body.Anime ( RobotUnitAnimeJn.Body.Pʍs,  RobotUnitAnimeڕW.Body.Pʍs,  ԋ );
            // {fBB ()
            this.Body.AnimeB( RobotUnitAnimeJn.Body.PʍsB, RobotUnitAnimeڕW.Body.PʍsB, ԋ );

            for (int i = 0; i < this.Arm.Length; i++)
            {
                this.Arm[i].Anime(RobotUnitAnimeJn.Arm[i], RobotUnitAnimeڕW.Arm[i], ԋ);
            }
        }




    }
}
