using System;
using System.Collections;
using System.Windows.Forms;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

using Direct3D = Microsoft.DirectX.Direct3D;

using DefineRobot;

namespace MyRobot
{
    public class robotArm
    {
        
        public  robotPart[] Parts;
        /*
            0    :r({fBւ̎t)
            1    :Or
            2    :̂Ђ      
			3/4  :w1
			5/6  :w2
			7/8  :w3
			9/10 :w4
			11/12:w5
        */

        private int m_wp^[ = 0;


        // ANZT ----------------------------------------------------------------------

        public int wp^[
        {
            get { return m_wp^[; }
        }


        /// <summary>
        /// 
        /// </summary>
        public robotArm()
        {
            // 
            // TODO: RXgN^ WbNɒǉĂB
            //
            Parts = new robotPart[13];
            for (int i = 0; i < Parts.Length; i++)
            {
                Parts[i] = null;
                Parts[i] = new robotPart();
            }

            /*
                0    :r({fBւ̎t)
                1    :Or
                2    :̂Ђ      
                3/4  :w1
                5/6  :w2
                7/8  :w3
                9/10 :w4
                11/12:w5
            */

            Parts[0].ef = null;       // r({fBt)
            Parts[1].ef = Parts[0];   // Or
            Parts[2].ef = Parts[1];   // ̂Ђ      

            // w (t)
            Parts[ 3].ef = Parts[2];
            Parts[ 5].ef = Parts[2];
            Parts[ 7].ef = Parts[2];
            Parts[ 9].ef = Parts[2];
            Parts[11].ef = Parts[2];

            // w ([)
            Parts[ 4].ef = Parts[ 3];
            Parts[ 6].ef = Parts[ 5];
            Parts[ 8].ef = Parts[ 7];
            Parts[10].ef = Parts[ 9];
            Parts[12].ef = Parts[11];

            // wJ
            float ang = (float)(45.0f * Math.PI / 180);
            Parts[ 3].RotateY_Yaw(ang *  2);
            Parts[ 5].RotateY_Yaw(ang *  1);
            Parts[ 7].RotateY_Yaw(ang *  0);
            Parts[ 9].RotateY_Yaw(ang * -1);
            Parts[11].RotateY_Yaw(ang * -2);
        }


        /// <summary>
        /// fB[vRs[
        /// </summary>
        public object Clone()
        {
            return new robotArm(this);
        }

        /// <summary>
        /// fB[vRs[pRXgN^
        /// sc:Rs[
        /// </summary>
        public robotArm(robotArm sc)
        {
            Parts = new robotPart[13];
            for (int i = 0; i < Parts.Length; i++)
            {
                Parts[i] = null;
                Parts[i] = (robotPart)sc.Parts[i].Clone();
            }
        }



        // {^NbNɂwp^[̐ؑ
        public void wp^[ؑ()
        {
            float ang;
            int p^[ = 7;
            Matrix m = Matrix.Identity;

            // w 
            for (int i = 3; i < 13; i++)
            {
                Parts[i].Pʍs = Matrix.Identity;
            }

            switch (this.m_wp^[)
            {
                case 0:
                    // i[
                    ang = (float)(180.0f * Math.PI / 180);
                    Parts[3].RotateY_Yaw(ang);
                    Parts[5].RotateY_Yaw(ang);
                    Parts[7].RotateY_Yaw(ang);
                    Parts[9].RotateY_Yaw(ang);
                    Parts[11].RotateY_Yaw(ang);
                    break;

                case 1:
                    //  1{
                    break;

                case 2:
                    // wJ
                    ang = (float)(45.0f * Math.PI / 180);
                    Parts[3].RotateY_Yaw(ang * 2);
                    Parts[5].RotateY_Yaw(ang * 1);
                    Parts[7].RotateY_Yaw(ang * 0);
                    Parts[9].RotateY_Yaw(ang * -1);
                    Parts[11].RotateY_Yaw(ang * -2);
                    break;

                case 3:
                    // wJ([O։΂)
                    ang = (float)(10.0f * Math.PI / 180);
                    Parts[3].RotateY_Yaw(ang * 2);
                    Parts[5].RotateY_Yaw(ang * 1);
                    Parts[7].RotateY_Yaw(ang * 0);
                    Parts[9].RotateY_Yaw(ang * -1);
                    Parts[11].RotateY_Yaw(ang * -2);

                    // w ([)
                    Parts[4].RotateY_Yaw(-ang * 2);
                    Parts[6].RotateY_Yaw(-ang * 1);
                    Parts[8].RotateY_Yaw(-ang * 0);
                    Parts[10].RotateY_Yaw(-ang * -1);
                    Parts[12].RotateY_Yaw(-ang * -2);

                    break;

                case 4:
                    // wJ(ԗl)
                    ang = (float)(45.0f * Math.PI / 180);
                    Parts[3].RotateX_Pitch(0);
                    Parts[5].RotateX_Pitch(ang);
                    Parts[7].RotateX_Pitch(-ang);
                    Parts[9].RotateY_Yaw(ang);
                    Parts[11].RotateY_Yaw(-ang);
                    break;

                case 5:
                    // wJ(ԗl)
                    // Tp` w̑IɋȂ
                    ang = (float)(72.0f * Math.PI / 180);
                    m = Matrix.Identity;
                    m.RotateY(1);

                    Parts[3].Pʍs = m;
                    Parts[5].Pʍs = m;
                    Parts[7].Pʍs = m;
                    Parts[9].Pʍs = m;
                    Parts[11].Pʍs = m;

                    m = Matrix.Identity;
                    m.RotateZ(ang);
                    Parts[3].Pʍs *= m;
                    m.RotateZ(ang*2);
                    Parts[5].Pʍs *= m;
                    m.RotateZ(ang*3);
                    Parts[7].Pʍs *= m;
                    m.RotateZ(ang*4);
                    Parts[9].Pʍs *= m;
                    m.RotateZ(ang*5);
                    Parts[11].Pʍs *= m;

                    // w ([)
                    m = Matrix.Identity;
                    m.RotateY(-ang);
                    Parts[4].Pʍs *= m;
                    Parts[6].Pʍs *= m;
                    Parts[8].Pʍs *= m;
                    Parts[10].Pʍs *= m;
                    Parts[12].Pʍs *= m;

                    break;


                case 6:
                    // wJ(ԗl)
                    // Tp` wL΂
                    ang = (float)(72.0f * Math.PI / 180);
                    m = Matrix.Identity;
                    m.RotateY(1);

                    Parts[3].Pʍs = m;
                    Parts[5].Pʍs = m;
                    Parts[7].Pʍs = m;
                    Parts[9].Pʍs = m;
                    Parts[11].Pʍs = m;

                    m = Matrix.Identity;
                    m.RotateZ(ang);
                    Parts[3].Pʍs *= m;
                    m.RotateZ(ang * 2);
                    Parts[5].Pʍs *= m;
                    m.RotateZ(ang * 3);
                    Parts[7].Pʍs *= m;
                    m.RotateZ(ang * 4);
                    Parts[9].Pʍs *= m;
                    m.RotateZ(ang * 5);
                    Parts[11].Pʍs *= m;
                    break;

                case 7:
                    // wJ(ԗl)
                    // Tp` wL΂
                    ang = (float)(72.0f * Math.PI / 180);   // 72=360/5
                    m = Matrix.Identity;
//                  m.RotateY(1);
                    m.RotateY((float)(80.0f * Math.PI / 180)); // 

                    Parts[3].Pʍs = m;
                    Parts[5].Pʍs = m;
                    Parts[7].Pʍs = m;
                    Parts[9].Pʍs = m;
                    Parts[11].Pʍs = m;

                    m = Matrix.Identity;
                    m.RotateZ(ang);
                    Parts[3].Pʍs *= m;
                    m.RotateZ(ang * 2);
                    Parts[5].Pʍs *= m;
                    m.RotateZ(ang * 3);
                    Parts[7].Pʍs *= m;
                    m.RotateZ(ang * 4);
                    Parts[9].Pʍs *= m;
                    m.RotateZ(ang * 5);
                    Parts[11].Pʍs *= m;
                    break;

            }
            this.m_wp^[++;
            if (p^[ < this.m_wp^[)
                this.m_wp^[ = 0;
        }

/*
        public void wp^[ؑ()
        {
            float ang;
            int p^[ = 2;

            // w 
            for (int i = 3; i < 13; i++)
            {
                Parts[i].Pʍs = Matrix.Identity;
            }

            switch (this.m_wp^[)
            {
                case 0:
                    break;
                case 1:
                    // wJ
                    ang = (float)(45.0f * Math.PI / 180);
                    Parts[3].RotateY_Yaw(ang * 2);
                    Parts[5].RotateY_Yaw(ang * 1);
                    Parts[7].RotateY_Yaw(ang * 0);
                    Parts[9].RotateY_Yaw(ang * -1);
                    Parts[11].RotateY_Yaw(ang * -2);
                    break;
                case 2:
                    // wJ
                    ang = (float)(30.0f * Math.PI / 180);
                    Parts[3].RotateY_Yaw(ang * 2);
                    Parts[5].RotateY_Yaw(ang * 1);
                    Parts[7].RotateY_Yaw(ang * 0);
                    Parts[9].RotateY_Yaw(ang * -1);
                    Parts[11].RotateY_Yaw(ang * -2);
                    break;
            }
            this.m_wp^[++;
            if (p^[ < this.m_wp^[)
                this.m_wp^[ = 0;
        }
*/

        /// <summary>
        ///  .configǍɐefĐݒ肷
        /// </summary>
        public void efݒ()
        {
            Parts[0].ef = null;       // r({fBt)
            Parts[1].ef = Parts[0];   // Or
            Parts[2].ef = Parts[1];   // ̂Ђ      

            // w (t)
            Parts[3].ef = Parts[2];
            Parts[5].ef = Parts[2];
            Parts[7].ef = Parts[2];
            Parts[9].ef = Parts[2];
            Parts[11].ef = Parts[2];

            // w ([)
            Parts[4].ef = Parts[3];
            Parts[6].ef = Parts[5];
            Parts[8].ef = Parts[7];
            Parts[10].ef = Parts[9];
            Parts[12].ef = Parts[11];
        }

/*
        // ver:ݒe Œ
        public void CreateVB( Device device )
        {
            float   r        = 2.0f-0.2f;
            float   w1       = 0.3f;
            float   w2       = 0.25f;

            float   ra      = 0.04f;
            float   wa1     = 0.015f;
            float   wa2     = 0.01f;

            float   r֐ߔa  = 0.1f;
            float   w֐ߔa  = 0.03f;

            // CreateVB( Device device, float p[c, float p[ca, float ֐ߔa )

            r = 2.0f - 0.2f;
            Parts[0].CreateVB(device, r, ra+0.02f, r֐ߔa);  //r({fBt)

            r = 2.0f - 0.4f;
            Parts[1].CreateVB(device, r, ra, r֐ߔa);        //Or

            r = 0.2f;
            ra = 0.055f;
            r֐ߔa = 0.06f;
            Parts[2].CreateVB(device, r, ra, r֐ߔa);        //̂Ђ      

            // w t
            w֐ߔa = 0.05f;
            Parts[3].CreateVB(device, w1, wa1, w֐ߔa);
            Parts[5].CreateVB(device, w1, wa1, w֐ߔa);
            Parts[7].CreateVB(device, w1, wa1, w֐ߔa);
            Parts[9].CreateVB(device, w1, wa1, w֐ߔa);
            Parts[11].CreateVB(device, w1, wa1, w֐ߔa);

            // w [
            w֐ߔa = 0.02f;
            Parts[4].CreateVB(device, w2, wa2, w֐ߔa);
            Parts[6].CreateVB(device, w2, wa2, w֐ߔa);
            Parts[8].CreateVB(device, w2, wa2, w֐ߔa);
            Parts[10].CreateVB(device, w2, wa2, w֐ߔa);
            Parts[12].CreateVB(device, w2, wa2, w֐ߔa);
        }
*/



        // f`t@CǍp
        public void CreateVB( Device device, `Arm `Arm )
        {
            for( int i = 0; i < `Arm.`Parts.Length; i++)
            {
                this.Parts[i].CreateVB(device,
                                        `Arm.`Parts[i].֐߃J[,
                                        `Arm.`Parts[i].p[cJ[,
                                        `Arm.`Parts[i].֐ߔa,
                                        `Arm.`Parts[i].,
                                        `Arm.`Parts[i].ta,
                                        `Arm.`Parts[i].[a );
            }
        }







        // obt@̊J
        public void Dispose()
        {
            for (int i = 0; i < Parts.Length; i++)
            {
                Parts[i].Dispose();
            }
        }



        public void Draw(Device device, ModelViewerCamera camera, Vector3 BodyW, Vector3 BodytʒuW, Matrix BodyPʍs, int PickPart)
        {
            // sbNꂽp[cFςĕ\
            bool bPick = false;

            if (0 == PickPart) bPick = true;

            try
            {
                Parts[0].DrawPartBodytʒu(device, camera, BodyW, BodytʒuW, BodyPʍs, bPick);

                for (int i = 1; i < Parts.Length; i++)
                {
                    if (i == PickPart) bPick = true;
                    else bPick = false;

                    Parts[i].DrawPart(device, camera, bPick);
                }

            }
            catch (Exception e)
            {
                throw (e);
            }
        }



        // AAA -----------
        public void Draw̎(
            Device device,
            ModelViewerCamera camera,
            Vector3 BodyW,
            Vector3 BodytʒuW,
            Matrix  BodyPʍs,
            Vector3 \ʒu,
            float   radY )  // ̎pYW]p

        {
            // sbNꂽp[cFςĕ\ => ł͖
            bool bPick = false;

            try
            {
                // \ʒuŒ̂߁ABodyW͌_
                Parts[0].DrawPartBodytʒu̎(device, camera, new Vector3(0,0,0), BodytʒuW, BodyPʍs, \ʒu, bPick, radY);

                for (int i = 1; i < Parts.Length; i++)
                {

                    Parts[i].DrawPart̎(device, camera, \ʒu, bPick, radY);
                }

            }
            catch (Exception e)
            {
                throw (e);
            }
        }



        /// <summary>
        /// Aj
        /// A[̊ep[c
        /// </summary>
        /// <param name="JnArm"></param>
        /// <param name="ڕWArm"></param>
        /// <param name="ԋ"></param>
        public void Anime(robotArm JnArm, robotArm ڕWArm, float ԋ)
        {
            try
            {
                for (int i = 0; i < Parts.Length; i++)
                {
                    Parts[i].Anime( JnArm.Parts[i].Pʍs, ڕWArm.Parts[i].Pʍs, ԋ );
                }
            }
            catch (Exception e)
            {
                throw (e);
            }
        }
    
    
    
    
    
    }
}
